<?php

ob_start();
$mod_use = array(
	'sql' => array('localhost', 'campaign', '', 'campaign'),
);

require 'pw.php';
require 'modules/modules.php';

if (!isset($_REQUEST['cstats'])) die('No campaign set');
$cid = intval($_REQUEST['cstats']);
if (!mod_checkTableID('campaigns', $cid)) die('Campaign not present');

$query = "SELECT stats FROM campaigns WHERE id = $cid";
$campaign = mysql_fetch_assoc(mod_mysql_querya($query));
if ($campaign['stats'] == 0 && $campaign['user_id'] != $userdata['id']) die('No Stats allowed');

$graph = new graph;
//$graph->equaldist = true;
$query = "SELECT time FROM log LEFT JOIN log_param ON log_id = log.id AND (INSTR(name, '-player_id') > 0 OR name = '[setstate]' OR name = '[use]' OR name = '[sell]') WHERE log.param = $cid AND log_param.id IS NOT NULL GROUP BY time ORDER BY time ASC";
$graph->rescale = mod_Query2Array($query, false, 0);
$graph->names[0] = 'Playtime in hours';

if (isset($_REQUEST['big']))
{
	$graph->sizex = 2048;
	$graph->sizey = 1536;
}

$defarray = array(strtotime('2006-05-1') => 0);
//$defarray = array();

switch($_REQUEST['gtype'])
{
	case 'money':
		$query = "SELECT MIN(timestamp) FROM money WHERE campaign_id = $cid AND timestamp > 0";
		$mintime = mysql_result(mod_mysql_querya($query), 0) - 100;
		$query = "SELECT SUM(money) as money, timestamp FROM money WHERE campaign_id = $cid GROUP BY timestamp ORDER BY timestamp ASC";
		$result = mod_mysql_querya($query);
		$moneys = $defarray;
		$money = 0;
		while ($tmp = mysql_fetch_assoc($result))
		{
			$moneys[max($mintime, $tmp['timestamp'])] = max(0, $money += $tmp['money']);
		}

		$graph->data = $moneys;
		$graph->multidata = 0;
		$graph->names[1] = 'Money (Current)';
		break;

	case 'money2':
		$query = "SELECT * FROM money WHERE campaign_id = $cid ORDER BY timestamp ASC";
		$result = mod_mysql_querya($query);
		$gained = $spent = $sold = $found = $defarray;
		$mgained = $mspent = $msold = $mfound = 0;
		while ($tmp = mysql_fetch_assoc($result))
		{
			if ($tmp['money'] > 0)
			{
				$mgained += $tmp['money'];
				$gained[$tmp['timestamp']] = $mgained;
				if ($tmp['item_id'])
				{
					$msold += $tmp['money'];
					$sold[$tmp['timestamp']] = $msold;
				}
				else
				{
					$mfound += $tmp['money'];
					$found[$tmp['timestamp']] = $mfound;
				}
			}
			else
			{
				$mspent -= $tmp['money'];
				$spent[$tmp['timestamp']] = $mspent;
			}
		}
		$graph->data = array('Gained' => $gained, 'Found' => $found, 'Sold' => $sold, 'Spent' => $spent);
		$graph->multidata = true;
		$graph->names[1] = 'Money (Extended)';
		break;

	case 'goods':
		$query = "SELECT * FROM money WHERE campaign_id = $cid AND money > 0 AND item_id = 0 ORDER BY timestamp ASC";
		$moneys = mod_Query2Array($query, false, false);

		$query = "SELECT * FROM items WHERE campaign_id = $cid AND deleted = 0 AND bought = 0 ORDER BY timestamp ASC";
		$items = mod_Query2Array($query, false, false);

		$i = $j = 0;
		$regular = $bonus = $full = $defarray;
		$mregular = $mbonus = $mfull = 0;
		while ($i < count($moneys) || $j < count($items))
		{
			if ($i < count($moneys) && ($j >= count($items) || $moneys[$i]['timestamp'] <= $items[$j]['timestamp']))
			{
				$tmpmoney = $moneys[$i]['money'];
				$tmpbonus = $moneys[$i]['bonus'];
				$tmptimestamp = $moneys[$i++]['timestamp'];
			}
			else
			{
				$tmpmoney = $items[$j]['value'] * $items[$j]['amount'];
				$tmpbonus = $items[$j]['bonus'];
				$tmptimestamp = $items[$j++]['timestamp'];
			}

			$mfull += $tmpmoney;
			$full[$tmptimestamp] = $mfull;
			if ($tmpbonus)
			{
				$mbonus += $tmpmoney;
				$bonus[$tmptimestamp] = $mbonus;
			}
			else
			{
				$mregular += $tmpmoney;
				$regular[$tmptimestamp] = $mregular;
			}
		}
		$graph->data = array('Full' => $full, 'Regular' => $regular, 'Bonus' => $bonus);
		$graph->multidata = true;
		$graph->names[1] = 'Full Value Gained';
		break;

	case 'xp':
		$query = "SELECT SUM(xp) as xp, timestamp FROM xp WHERE campaign_id = $cid GROUP BY timestamp ORDER BY timestamp ASC";
		$result = mod_mysql_querya($query);
		$xps = $xps2 = $xps3 = $defarray;
		$xp = $xp2 = $xp3 = 0;
		while ($tmp = mysql_fetch_assoc($result))
		{
			$xps[$tmp['timestamp']] = -($xp += min(0, $tmp['xp']));
			$xps2[$tmp['timestamp']] = ($xp2 += max(0, $tmp['xp']));
			$xps3[$tmp['timestamp']] = ($xp3 += $tmp['xp']);
		}

		$graph->data = array('Lost' => $xps, 'Gained' => $xps2, 'Current' => $xps3);
		$graph->multidata = array('Lost' => 65536 * 255, 'Gained' => 256 * 255, 'Current' =>255);
		$graph->names[1] = 'Experience';
		break;

	case 'story':
		$query = "SELECT * FROM story WHERE state > 1 ORDER BY state_timestamp ASC";
		$result = mod_mysql_querya($query);
		$storydone = $storyfailed = $storyobs = $defarray;
		$states = array(2 => 0, 3 => 0, 4 => 0);
		while ($tmp = mysql_fetch_assoc($result))
		{
			$states[$tmp['state']]++;
			$storydone[$tmp['state_timestamp']] = $states[2];
			$storyfailed[$tmp['state_timestamp']] = $states[3];
			$storyobs[$tmp['state_timestamp']] = $states[4];
		}
		$graph->data = array('Done' => $storydone, 'Failed' => $storyfailed, 'Obsolete' => $storyobs);
		$graph->multidata = array('Done' => 256 * 255, 'Failed' => 65536 * 255, 'Obsolete' => 255);
		$graph->names[1] = 'Story Elements';
		break;

	case 'items':
		$query = "SELECT players.* FROM players LEFT JOIN possession ON player_id = players.id WHERE players.campaign_id = $cid AND possession.id IS NOT NULL GROUP BY players.id";
		$players = mod_Query2Array($query, false, false, MYSQL_ASSOC);
		$players[] = array('id' => 0, 'name' => 'Group');

		$query = "SELECT start FROM possession WHERE campaign_id = $cid ORDER BY start ASC";
		$result = mod_mysql_querya($query);
		$data = array();
		while ($tmp = mysql_fetch_assoc($result))
		{
			foreach ($players as $player)
			{
				if (!isset($_GET['validplayers']) || in_array($player['id'], explode(',', $_GET['validplayers'])))
				{
					$query = "SELECT
							IFNULL(SUM(items.value * items.amount), 0)
						FROM possession
						LEFT JOIN items ON item_id = items.id
						WHERE possession.player_id = $player[id] AND start <= $tmp[start] AND (`end` > $tmp[start] OR (end = 0 AND items.sold = 0 AND items.player_id = $player[id] AND deleted = 0))";
					$result2 = mysql_result(mod_mysql_querya($query), 0);

					$query = "SELECT
							IFNULL(SUM(items.value * items.amount), 0)
						FROM items
						LEFT JOIN possession ON item_id = items.id AND possession.player_id = $player[id] AND possession.start <= $tmp[start] AND (possession.`end` > $tmp[start] OR end = 0)
						WHERE possession.id IS NULL AND items.player_id = $player[id] AND items.sold = 0 AND items.deleted = 0 AND items.campaign_id = $cid AND items.timestamp <= $tmp[start]";
					$result3 = mysql_result(mod_mysql_querya($query), 0);

					if (!isset($data[$player['name']])) $data[$player['name']] = $defarray;
					$data[$player['name']][$tmp['start']] = $result2 + $result3;
				}
			}
		}
		$graph->data = $data;
		$graph->multidata = true;
		$graph->names[1] = 'Item Value';
		break;

	default:
		unset($graph);
		break;
}

if (!isset($graph)) die('Invalid Type');
echo CreateGraph($graph);

?>
