mod_htmledittext = [];
mod_htmledittype = [];
mod_htmleditimgbase = [];

function mod_tbmousedown(obj)
{
	obj.style.left = 2;
	obj.style.top = 2;
	obj.style.border="inset 2px";
}

function mod_tbmouseup(obj)
{
	obj.style.left = 1;
	obj.style.top = 1;
	obj.style.border="outset 2px";
}

function mod_tbmouseout(obj)
{
	obj.style.border="";
}

function mod_tbmouseover(obj)
{
	obj.style.border="outset 2px";
}

function mod_insertNodeAtSelection(win, insertNode)
{
	// get current selection
	var sel = win.getSelection();

	// get the first range of the selection
	// (there's almost always only one range)
	var range = sel.getRangeAt(0);

	// deselect everything
	sel.removeAllRanges();

	// remove content of current selection from document
	range.deleteContents();

	// get location of current selection
	var container = range.startContainer;
	var pos = range.startOffset;

	// make a new range for the new selection
	range=document.createRange();

	if (container.nodeType==3 && insertNode.nodeType==3)
	{
		// if we insert text in a textnode, do optimized insertion
		container.insertData(pos, insertNode.nodeValue);

		// put cursor after inserted text
		range.setEnd(container, pos+insertNode.length);
		range.setStart(container, pos+insertNode.length);
	}
	else
	{
		var afterNode;
		if (container.nodeType==3)
		{

			// when inserting into a textnode
			// we create 2 new textnodes
			// and put the insertNode in between

			var textNode = container;
			container = textNode.parentNode;
			var text = textNode.nodeValue;

			// text before the split
			var textBefore = text.substr(0,pos);
			// text after the split
			var textAfter = text.substr(pos);

			var beforeNode = document.createTextNode(textBefore);
			afterNode = document.createTextNode(textAfter);

			// insert the 3 new nodes before the old one
			container.insertBefore(afterNode, textNode);
			container.insertBefore(insertNode, afterNode);
			container.insertBefore(beforeNode, insertNode);

			// remove the old node
			container.removeChild(textNode);
		}
		else
		{
			// else simply insert the node
			afterNode = container.childNodes[pos];
			container.insertBefore(insertNode, afterNode);
		}
		range.setEnd(afterNode, 0);
		range.setStart(afterNode, 0);
	}
	sel.addRange(range);
}

function mod_getOffsetTop(elm)
{
	var mOffsetTop = elm.offsetTop;
	var mOffsetParent = elm.offsetParent;

	while(mOffsetParent)
	{
		mOffsetTop += mOffsetParent.offsetTop;
		mOffsetParent = mOffsetParent.offsetParent;
	}
 
	return mOffsetTop;
}

function mod_getOffsetLeft(elm)
{

	var mOffsetLeft = elm.offsetLeft;
	var mOffsetParent = elm.offsetParent;

	while(mOffsetParent)
	{
		mOffsetLeft += mOffsetParent.offsetLeft;
		mOffsetParent = mOffsetParent.offsetParent;
	}
 
	return mOffsetLeft;
}

var mod_curhtmledit = -1;

function CheckObjIsValid(obj)
{
	while (obj.parentNode != undefined)
	{
		if (obj.tagName == "DIV" && obj.getAttribute("htmledit") == 1)
		{
			return(true);
		}
		obj = obj.parentNode;
	}
	return(false);
}

function InsertText(text)
{
	document.getElementById('mod_htmledit' + mod_curhtmledit).contentWindow.focus();
	sel = document.getElementById('mod_htmledit' + mod_curhtmledit).contentWindow.document.selection.createRange();

	sel.pasteHTML(text + (sel.text == '' ? ' ' : ''));
	sel.select();
}

function mod_tbclick(obj)
{
	if (mod_curhtmledit == -1) return;
	cmd = obj.parentNode.id.substr(4);

	if ((cmd == "forecolor") || (cmd == "hilitecolor"))
	{
		parent.command = cmd;
		buttonElement = document.getElementById(obj.parentNode.id);
		document.getElementById("mod_colorpalette").style.left = mod_getOffsetLeft(buttonElement);
		document.getElementById("mod_colorpalette").style.top = mod_getOffsetTop(buttonElement) + buttonElement.offsetHeight;
		document.getElementById("mod_colorpalette").style.visibility="visible";
	}
	else if (cmd == "createlink")
	{
		var szURL = prompt("Enter a URL:", "http://");
		if ((szURL != null) && (szURL != ""))
		{
			document.getElementById('mod_htmledit' + mod_curhtmledit).contentWindow.document.execCommand("CreateLink",false,szURL);
		}
	}
	else if (cmd == "createimage")
	{
		document.getElementById('mod_htmledit' + mod_curhtmledit).contentWindow.focus();
		imagePath = prompt('Enter Image URL:', mod_htmleditimgbase[mod_curhtmledit]);
		if ((imagePath != null) && (imagePath != ""))
		{
			document.getElementById('mod_htmledit' + mod_curhtmledit).contentWindow.document.execCommand('InsertImage', false, imagePath);
		}
	}
	else if (cmd == "createtable")
	{
		document.getElementById('mod_htmledit' + mod_curhtmledit).contentWindow.focus();
		e = document.getElementById('mod_htmledit' + mod_curhtmledit);
		rowstext = prompt("enter rows", 1);
		colstext = prompt("enter cols", 1);
		rows = parseInt(rowstext);
		cols = parseInt(colstext);
		if ((rows > 0) && (cols > 0))
		{
			table = e.contentWindow.document.createElement("table");
			table.setAttribute("border", "1");
			table.setAttribute("cellpadding", "2");
			table.setAttribute("cellspacing", "2");
			tbody = e.contentWindow.document.createElement("tbody");
			for (var i=0; i < rows; i++)
			{
				tr =e.contentWindow.document.createElement("tr");
				for (var j=0; j < cols; j++)
				{
					td =e.contentWindow.document.createElement("td");
					br =e.contentWindow.document.createElement("br");
					td.appendChild(br);
					tr.appendChild(td);
				}
				tbody.appendChild(tr);
			}
			table.appendChild(tbody);

			if (document.all)
			{
				InsertText('<table border=1>' + table.innerHTML + '</table>');
			}
			else
			{

				mod_insertNodeAtSelection(e.contentWindow, table);
			}
		}
	}
	else
	{
		document.getElementById('mod_htmledit' + mod_curhtmledit).contentWindow.document.execCommand(cmd, false, null);
	}
}

function mod_Select(selectname)
{
	if (mod_curhtmledit == -1) return;
	var cursel = document.getElementById(selectname).selectedIndex;
	// First one is always a label

	if (cursel != 0)
	{
		var selected = document.getElementById(selectname).options[cursel].value;
		document.getElementById('mod_htmledit' + mod_curhtmledit).contentWindow.document.execCommand(selectname, false, selected);
		document.getElementById('mod_htmledit' + mod_curhtmledit).contentWindow.focus();
		document.getElementById(selectname).selectedIndex = 0;
	}
}

function mod_dismisscolorpalette()
{
	document.getElementById("mod_colorpalette").style.visibility="hidden";
}

function mod_CreateHtmlEdit(id, obj)
{
	if (!document.all && ((tmp = document.getElementById('mod_htmledit' + id)) === undefined || (tmp = tmp.contentWindow) === undefined ||
		(tmp = tmp.document) === undefined || tmp.body === undefined || tmp.body.innerHTML === undefined))
	{
		window.setTimeout('mod_CreateHtmlEdit(' + id + ', "' + text + '");', 50);
	}
	else
	{
		tmp = obj;

		if (document.all)
		{
			var tmpDiv = tmp.createElement('div');
			tmp.body.appendChild(tmpDiv);
			tmpDiv.innerHTML = mod_htmledittext[id];
			tmpDiv.contentEditable = true;
			tmpDiv.id = 'mod_htmledit_div_' + id;
		}
		else
		{
			tmp.designMode = 'on';
			tmp.body.innerHTML = mod_htmledittext[id];
		}

		if (document.all)
		{
			tmp.onmousedown = new Function("", "mod_htmlediteventa(" + id + ");");
			tmp.onmouseup = new Function("", "mod_htmlediteventa(" + id + ");");
			tmp.onkeypress = new Function("", "mod_htmlediteventa(" + id + ");");
		}
		else if (document.addEventListener)
		{
			tmp.addEventListener("mouseup", new Function("", "mod_htmlediteventa(" + id + ");"), true);
			tmp.addEventListener("mousedown", new Function("", "mod_htmlediteventa(" + id + ");"), true);
			tmp.addEventListener("keypress", new Function("", "mod_htmlediteventa(" + id + ");"), true);
		}
		else if (document.attachEvent)
		{
			tmp.attachEvent("mouseup", new Function("", "mod_htmlediteventa(" + id + ");"), true);
			tmp.attachEvent("mousedown", new Function("", "mod_htmlediteventa(" + id + ");"), true);
			tmp.attachEvent("keypress", new Function("", "mod_htmlediteventa(" + id + ");"), true);
		}
	}
}

function mod_changehtmledittext(id)
{
	if (mod_htmledittype[id] == 1) return;
	obj = document.getElementById('mod_htmledit' + id).contentWindow.document;
	if (document.all)
	{
		obj = obj.getElementById('mod_htmledit_div_' + id);
	}
	else
	{
		obj = obj.body;
	}
	document.getElementById('mod_htmledittext' + id).value = obj.innerHTML;

	document.getElementById('mod_htmledittext' + id).style.display = '';
	document.getElementById('mod_htmledit' + id).style.display = 'none';

	mod_htmledittype[id] = 1;
	if (id == mod_curhtmledit) mod_curhtmledit = -1;
}

function mod_changehtmledithtml(id)
{
	if (mod_htmledittype[id] == 0) return;

	obj = document.getElementById('mod_htmledit' + id).contentWindow.document;
	if (document.all)
	{
		obj = obj.getElementById('mod_htmledit_div_' + id);
	}
	else
	{
		obj = obj.body;
	}

	obj.innerHTML =	document.getElementById('mod_htmledittext' + id).value;

	document.getElementById('mod_htmledittext' + id).style.display = 'none';
	document.getElementById('mod_htmledit' + id).style.display = '';

	mod_htmledittype[id] = 0;
}

function mod_changehtmledit(id, obj)
{
	if (obj.checked)
	{
		mod_changehtmledithtml(id);
	}
	else
	{
		mod_changehtmledittext(id);
	}
}

function mod_htmlediteventa(id)
{
	mod_dismisscolorpalette();
	mod_curhtmledit = id;
}

function mod_htmlediteventb(event)
{
	mod_htmlediteventa(-1);
}

function mod_htmleditevent(obj)
{
	mod_htmlediteventa(0);
}