<?php

function CreateTableHeader($table_data, $iHeader, $rowNamesA, $defaultlink)
{
	global $mod_dwTableInstance;

	$headerout = "<tr";
	$headerout .= ' sorttable=1';
	if ($table_data->titleClass != '' && $table_data->title != '' && $iHeader == 0)
	{
		$headerout .= " class='$table_data->titleClass'";
	}
	else if ($table_data->headerClass != '')
	{
		$headerout .= " class='$table_data->headerClass'";
	}
	if ($table_data->inTr != '')
	{
		$headerout .= ' ' . $table_data->inTr;
	}
	if ($table_data->highlight)
	{
		$headerout .= " onMouseOver='mod_TableMouseOutB();'";
	}
	$headerout .= ">";
	if ($table_data->inTh != '')
	{
		$CreateTableHeader_inTh = ' ' . $table_data->inTh;
	}
	else
	{
		$CreateTableHeader_inTh = '';
	}

	if ($table_data->title == '' || $iHeader == 1)
	{
		if (count($table_data->rowNames) == 0)
		{
			return('');
		}

		for ($i = 0;$i < count($rowNamesA);$i++)
		{
			$headerout .= "<th" . $CreateTableHeader_inTh;
			if (isset($table_data->colWidths[$i]))
			{
				$headerout .= " width='" . $table_data->colWidths[$i] . "'";
			}
			else if (isset($table_data->colWidths[$table_data->rowNames[$i]]))
			{
				$headerout .= " width='" . $table_data->colWidths[$table_data->rowNames[$i]] . "'";
			}

			if ($table_data->vHighlight)
			{
				$headerout .= ' onMouseOver="mod_Table_colover(this, 1);" onMouseOut="mod_Table_colout(this, 1);"';
			}
			$headerout .= ">";
			if ($table_data->sortable)
			{
				$headerout .= "<a href='" . htmlspecialchars("JavaScript:mod_serverSortLink(\"" . addslashes($defaultlink) . '", "' . $_GET["mod_sortBy$mod_dwTableInstance"] . '", ' . $i . ',' . $mod_dwTableInstance . ');' , ENT_QUOTES) . "'>";
			}
			$headerout .= $rowNamesA[$i];

			if ($table_data->sortable && $table_data->sortBy !== false && count($table_data->sortBy))
			{
				$headerout .= "</a>";

				if (in_array($i, $table_data->sortBy, true))
				{
					$headerout .= ($table_data->sortByOrder[array_search($i, $table_data->sortBy)] == 1 ? "&#8593;" : "&#8595;");
				}
				else if (in_array($table_data->rowNames[$i], $table_data->sortBy, true))
				{
					$headerout .= ($table_data->sortByOrder[array_search($table_data->rowNames[$i], $table_data->sortBy)] == 1 ? "&#8593;" : "&#8595;");
				}
			}

			$headerout .= "</th>";
		}
	}
	else
	{
		$headerout .= "<th $CreateTableHeader_inTh " . (count($table_data->data) ? " colspan=" . count($table_data->data[0]) : "") . ">$table_data->title</th>";
	}

	$headerout .= "</tr>";

	return($headerout);
}

function mod_table_sort_comparison($a, $b)
{
	global $mod_comparison_sortBy, $mod_comparison_sortOrder;

	for ($i = 0;$i < count($mod_comparison_sortBy);$i++)
	{
		$vala = $a[$mod_comparison_sortBy[$i]];
		$valb = $b[$mod_comparison_sortBy[$i]];
		$cmp = strnatcasecmp(str_ireplace(array('', '', '', ''), array('ae', 'oe', 'ue', ''), is_array($vala) ? $vala[1] : $vala), str_ireplace(array('', '', '', ''), array('ae', 'oe', 'ue', ''), is_array($valb) ? $valb[1] : $valb));
		if ($cmp != 0)
		{
			return($cmp * $mod_comparison_sortOrder[$i]);
		}
	}
	return(0);
}

function CreateServerTable($table_data, $rowNamesA)
{
	global $mod_dwTableInstance;
	global $mod_comparison_sortBy, $mod_comparison_sortOrder;

	if (isset($_GET["mod_sortBy$mod_dwTableInstance"]) && strpos($_GET["mod_sortBy$mod_dwTableInstance"], ':'))
	{
		$sortBy = explode('/', $_GET["mod_sortBy$mod_dwTableInstance"]);
		$table_data->sortBy = $table_data->sortByOrder = array();
		if ($table_data->pagesize < 0)
		{
			$table_data->sortBy[0] = -1-$table_data->pagesize;
			$table_data->sortByOrder[0] = 1;
		}
		$dwPage = intval($sortBy[1]);
		$sortBy = explode(',', $sortBy[0]);
		foreach($sortBy as $sort)
		{
			$sort = explode(':', $sort);
			if (is_numeric($sort[0]) ? $sort[0] >= count($table_data->rowNames) : !in_array($sort[0], $table_data->rowNames)) continue;
			if ($table_data->pagesize >= 0 || -1-$table_data->pagesize != intval($sort[0]))
			{
				$table_data->sortBy[] = intval($sort[0]);
				$table_data->sortByOrder[] = intval($sort[1]);
			}
		}
	}
	else
	{
		if (isset($_GET["mod_sortBy$mod_dwTableInstance"]) && strpos($_GET["mod_sortBy$mod_dwTableInstance"], '/') === 0)
		{
			$dwPage = intval(substr($_GET["mod_sortBy$mod_dwTableInstance"], 1));
		}
		else
		{
			$dwPage = 1;
		}
		$buildSortBy = 'mod_sortBy' . $mod_dwTableInstance;
		$_GET[$buildSortBy] = array();
	}

	if (is_array($table_data->sortBy) && count($table_data->sortBy) && count($table_data->data))
	{
		$mod_comparison_sortBy = $table_data->sortBy;
		$mod_comparison_sortOrder = $table_data->sortByOrder;
		$buildSortByTmp = array();
		for ($i = 0;$i < count($mod_comparison_sortBy);$i++)
		{
			if (is_numeric($mod_comparison_sortBy[$i]))
			{
				$buildSortByTmp[] = $table_data->sortBy[$i];
				$mod_comparison_sortBy[$i] = $table_data->rowNames[$mod_comparison_sortBy[$i]];
			}
			else 
			{
				$buildSortByTmp[] = array_search($table_data->sortBy[$i], $table_data->rowNames);
			}
			if (!isset($mod_comparison_sortOrder[$i]))
			{
				$mod_comparison_sortOrder[$i] = 1;
			}
			if (isset($buildSortBy))
			{
				$_GET[$buildSortBy][] = $buildSortByTmp[$i] . ':' . $mod_comparison_sortOrder[$i];
			}

		}
		usort($table_data->data, 'mod_table_sort_comparison');
	}
	if (isset($buildSortBy))
	{
		$_GET[$buildSortBy] = implode(',', $_GET[$buildSortBy]) . '/1';
	}

	$defaultlink = explode('?', $table_data->defaultlink, 2);
	if (count($defaultlink) > 1)
	{
		$defaultlink[1] = explode('&', $defaultlink[1]);
		for ($i = 0;$i < count($defaultlink[1]);$i++)
		{
			if (strpos($defaultlink[1][$i], "mod_sortBy$mod_dwTableInstance=") === 0)
			{
				array_splice($defaultlink[1], $i, 1);
				break;
			}
		}
		$defaultlink[1] = implode('&', $defaultlink[1]);
	}
	$defaultlink = implode('?', $defaultlink);

	if ($table_data->pagesize == 0) $dwPage = 0;

	$txtout = "<a name='mod_table$mod_dwTableInstance'></a><table dwTableInstance=$mod_dwTableInstance";
	if ($table_data->tableClass != '')
	{
		$txtout .= " class='$table_data->tableClass'";
	}
	if ($table_data->width != '')
	{
		$txtout .= " width='$table_data->width'";
	}
	if ($table_data->inTable != '')
	{
		$txtout .= ' ' . $table_data->inTable;
	}
	$txtout .= '>';

	for ($iHeader = 0;$iHeader <= intval($table_data->title != '') + intval($table_data->repeatHeader >= 0) - 1;$iHeader++)
	{
		$txtout .= CreateTableHeader($table_data, $iHeader, $rowNamesA, $defaultlink);
	}

	$lines = array();

	$iStart = 0;
	$iEnd = count($table_data->data);
	if ($table_data->pagesize > 0 && $dwPage)
	{
		$iStart = ($dwPage - 1) * $table_data->pagesize;
		$iEnd = min(count($table_data->data), $dwPage * $table_data->pagesize);
	}
	else if ($table_data->pagesize < 0 && $dwPage)
	{
		if ($dwPage > 1)
		{
			for ($i = 0;$i < count($table_data->data);$i++)
			{
				if (strtoupper($table_data->data[$i][$table_data->rowNames[-1-$table_data->pagesize]]{0}) == chr($dwPage + 63))
				{
					break;
				}
			}
			$iStart = $i;
		}
		if ($dwPage)
		{
			for ($i = $iStart;$i < count($table_data->data);$i++)
			{
				$tmp = strtoupper($table_data->data[$i][$table_data->rowNames[-1-$table_data->pagesize]]{0});
				if ($dwPage > 1 ? $tmp != chr($dwPage + 63) : ($tmp >= 'A' && $tmp <= 'Z'))
				{
					break;
				}
			}
			$iEnd = $i;
		}
	}

	for ($i = 0;$i < $iEnd - $iStart;$i++)
	{
		if ($i && $table_data->repeatHeader > 0 && ($i % $table_data->repeatHeader == 0))
		{
			$lines[] = CreateTableHeader($table_data, 1, $rowNamesA, $defaultlink);
		}

		$line = "<tr line=$i";
		$line .= ' sorttable=1';

		if (count($table_data->styles))
		{
			$line .= ' class="' . $table_data->styles[$i % count($table_data->styles)] . '"';
		}
		if ($table_data->highlight)
		{
			$line .= ' onMouseOver=\'mod_TableMouseOver(this,"' . $table_data->highlightColours[$i % count($table_data->highlightColours)] . '");\' onMouseOut=\'mod_TableMouseOut(this);\'';
		}
		if ($table_data->inTr != '')
		{
			$line .= ' ' . $table_data->inTr;
		}

		$line .= ">";
		for ($j = 0;$j < count($table_data->rowNames);$j++)
		{
			if (in_array($j, array_keys($table_data->darkened), true) || in_array($table_data->rowNames[$j], array_keys($table_data->darkened)))
			{
				$line .= "<th";
				$line .= " class='" . $table_data->darkenedStyles[$i % count($table_data->darkenedStyles)] . "'";
				if ($table_data->vHighlight)
				{
					$line .= ' onMouseOver="mod_Table_coloutB();"';
				}
			}
			else
			{
				$line .= "<td";
				if ($table_data->vHighlight)
				{
					$line .= ' onMouseOver="mod_Table_colover(this, 0);" onMouseOut="mod_Table_colout(this,0)"';
				}
			}
			if ($table_data->inTd != '')
			{
				$line .= ' ' . $table_data->inTd;
			}
			if (isset($table_data->inTds[$j]))
			{
				$line .= ' ' . $table_data->inTds[$j];
			}
			if (isset($table_data->inTds[$table_data->rowNames[$j]]))
			{
				$line .= ' ' . $table_data->inTds[$table_data->rowNames[$j]];
			}
			$line .= ">";
			$tmpline = $table_data->data[$i+$iStart][$table_data->rowNames[$j]];
			$line .= is_array($tmpline) ? $tmpline[0] : $tmpline;
			$line .= "</td>";
		}
		$line .= "</tr>";

		$lines[] = $line;
	}

	$lines[] = "</table>";
	if ($table_data->pagesize && ($table_data->pagesize < count($table_data->data) || $table_data->pagesize < 0))
	{
		if (strpos($defaultlink, '?') === false)
		{
			$defaultlink .= '?';
		}
		else
		{
			$defaultlink .= '&';
		}
		$defaultlink .= "mod_sortBy$mod_dwTableInstance=";
		$sortBy = explode('/', $_GET["mod_sortBy$mod_dwTableInstance"]);
		$defaultlink .= $sortBy[0] . '/';

		for ($i = 1;$i <= ($table_data->pagesize < 0 ? 27 : count($table_data->data) / $table_data->pagesize + (count($table_data->data) % $table_data->pagesize != 0));$i++)
		{
			$lines[] = "<a href='$defaultlink$i#mod_table$mod_dwTableInstance'>" . ($dwPage == $i ? "<b>" : "") . ($table_data->pagesize < 0 ? ($i > 1 ? chr($i + 63) : '#') : $i) . ($dwPage == $i ? "</b>" : "") . "</a> ";
		}
		$lines[] = "<a href='$defaultlink" . "0#mod_table$mod_dwTableInstance'>" . ($dwPage == 0 ? "<b>" : "") . "Alle" . ($dwPage == 0 ? "</b>" : "") . "</a>";
	}

	return($txtout . implode('', $lines));
}

?>
