<?php

function mod_GenerateStdArray()
{
	global $userdata, $mod_txt, $mod_templates;
	$mod_templates = array(
		'news' => array(
			'table' => array(
				'caption' => array('text' => 0),
				'text' => array('text' => 0),
				'timestamp' => array('int' => 11)
			),
			'relations' => array(
				'caption' => array('name' => 'Caption', 'formname' => $mod_txt['std_caption'], 'force' => true),
				'text' => array('name' => 'News', 'formname' => $mod_txt['std_text'], 'force' => true, 'rows' => 5)
			),
			'vars' => array(
				'text' => "<tr><td valign=top width=200><b>[USER]</b> [EMAIL]<br>SELECT[Date]</td><td valign=top><b>TABLE[caption]</b>TABLE[text][FUNCTIONS]</td></tr>",
				'seperator' => '<tr><td height=30><hr></td><td><hr></td></tr>',
				'pretext' => '<table cellpadding=8 width=90%>',
				'posttext' => '<tr><td><hr></td><td><hr></td></tr></table>',
				'prefunctions' => '<br><br>',
				'adddate' => true
			),
			'editdata' => array(
				'name' => $mod_txt['std_news'],
				'title' => $mod_txt['std_entries']
			)
		),

		'galery' => array(
			'table' => array(
				'filename' => array('text' => 0),
				'text' => array('text' => 0)
			),
			'relations' => array(
				'file' => array('name' => 'Image', 'type' => 'file', 'force' => true, 'filename' => 'filename', 'filesize' => '500K', 'hide' => true, 'storage' => './storage/'),
				'filename' => array('name' => 'Filename', 'type' => 'hidden'),
				'text' => array('name' => 'Text', 'rows' => 4)
			),
			'vars' => array(
				'text' => "[IMAGE]<br>TABLE[text]<br>[FUNCTIONS]",
				'seperator' => '',
				'pretext' => '<table cellpadding=5 width=90%>',
				'posttext' => '</table>'
			),
			'forcevars' => array(
				'adduser' => false,
				'adddate' => false
			),
			'editdata' => array(
				'namefield' => 'filename',
				'title' => $mod_txt['std_images']
			)
		),

		'comments' => array(
			'table' => array(
				'text' => array('text' => 0),
				'table' => array('text' => 0, 'index' => array('table' => 16, 'ref' => 0)),
				'ref' => array('int' => 11),
				'user_id' => array('int' => 11),
				'timestamp' => array('int' => 11)
			),
			'relations' => array(
				'text' => array('name' => $mod_txt['std_comment'], 'force' => true)
			),
			'vars' => array(
				'text' => "<b>[USER]</b> SELECT[Date]<br>TABLE[text][FUNCTIONS]",
				'seperator' => '<br><br><hr>',
				'posttext' => '<hr>',
				'adddate' => true,
				'addchange' => true,
				'prefunctions' => '<br><br>'
			),
			'forcevars' => array(
				'comments' => false
			),
			'editdata' => array(
				'name' => $mod_txt['std_comment']
			)
		),

		'polls' => array(
			'table' => array(
				'name' => array('text' => 0)
			),
			'relations' => array(
				'name' => array('name' => $mod_txt['std_poll'], 'force' => true, 'nodual' => true),
				'selections' => array('name' => $mod_txt['std_poll_select'], 'type' => 'multi', 'sqllinkdata' => array('poll_id' => '[ID]', 'name' => '[LINK]'), 'hide' => true, 'editable' => false, 'multitextdata' => array('', '', ''))
			),
			'vars' => array(
				'adddate' => true
			),
			'forcevars' => array(
				'showtable' => true
			),
			'editdata' => array(
				'title' => $mod_txt['std_polls']
			)
		),
		'forum' => array(
			'table' => array(
				'name' => array('text' => 0),
				'text' => array('longtext' => 0),
				'user_id' => array('int' => 11, 'index' => 0),
				'timestamp' => array('int' => 11),
				'root' => array('int' => 11, 'index' => 0),
				'thread' => array('tinyint' => 4),
				'views' => array('int' => 11, 'default' => 0)
			),
			'relations' => array(
				'name' => array('name' => 'Caption', 'force' => true),
				'text' => array('name' => 'Text', 'rows' => 10),
				'mod_template_callback' => 'mod_Newstemplate_forum_rel'
			),
			'vars' => array(
				'adddate' => true,
				'callback' => 'mod_newstemplate_forum',
				'callback_late' => 'mod_Newstemplate_forum_late',
				'dirselect' => "
					SELECT
						mod_tmptable.*,
						IF(Sub=0,'',Sub) AS Posts,
						IF(Sub=0,'',CONCAT(mod_tmpusertable.username, '<i style=\"font-size:90%;\"> (',
						DATE_FORMAT(FROM_UNIXTIME(mod_tmptable.LastStamp), '%e.%c.%Y %H:%i:%s'), ')</i>')) AS Last
						
					FROM(
						SELECT
							`[TABLE]`.id,
							`[USER]`.username AS User,
							COUNT(mod_tmpforumtable.id) AS Sub,
							DATE_FORMAT(FROM_UNIXTIME(`[TABLE]`.timestamp), '%e.%c.%Y %H:%i:%s') AS Time,
							IF(`[TABLE]`.thread>0,`[TABLE]`.views,'') AS Views,
							MAX(mod_tmpforumtable.timestamp) AS LastStamp
						FROM
							`[TABLE]`
						LEFT JOIN `[USER]`
							ON `[TABLE]`.user_id = `[USER]`.id
						LEFT JOIN `[TABLE]` AS mod_tmpforumtable ON
							`[TABLE]`.id = mod_tmpforumtable.root
						WHERE
							`[TABLE]`.id = [ID]
						GROUP BY
							`[TABLE]`.id
					) AS mod_tmptable
					LEFT JOIN
						`[TABLE]` AS mod_tmpforumtable2
					ON
						mod_tmpforumtable2.root = mod_tmptable.id AND mod_tmpforumtable2.timestamp = mod_tmptable.LastStamp
					LEFT JOIN
						`[USER]` AS mod_tmpusertable
					ON
						mod_tmpforumtable2.user_id = mod_tmpusertable.id
					GROUP BY
						mod_tmptable.id
					"
			),
			'forcevars' => array(
				'showtable' => 'mod_CreateNewsTemplateB',
				'adduser' => 1,
				'addemail' => 2,
				'requirerights' => -2
			),
			'dirdata' => array(
				'tabledata' => array(
					'title' => 'Forum',
					'colWidths' => array('Edit' => '1%'),
					'inTds' => array('User' => 'align=center', 'Last Reply' => 'align=center', 'Posts' => 'align=center')
				),
				'dirname' => $mod_txt['std_forum_forum'],
				'keeplines' => false,
				'changeroot' => array('IF(thread>=1,1,0)' => 1),
				'indenttxt' => 20,
				'html' => '<table width=100%><tr><td valign=top><div><b style="font-size:120%;">[NAME]',
				'rootname' => $mod_txt['std_forum_forum']
			),
			'editdata' => array(
				'sortableadd' => true,
			)
		)
	);
}

class newstemplate
{
	public $template = 'news';			//Type of Template (news)
	public $template_parameter = array();		//Template Param
	public $sql = false;
	public $table = false;
	public $adduser = true;				//Add User who added this (If set to true (not 1) if no user is logged in, a Name field is appended), 2 to add user field
	public $addemail = false;			//Add Email (From User DB if exists, otherwise from table), 1 to force email field, 2 to force from Userdb
	public $anonymous = false;			//Allow to add something if not logged in
	public $requirerights = -1;			//Rights required to add something (false for none), -2 to force user logged in
	public $editrights = -1;			//Rights required to edit something (false for none), -2 as above
	public $editown = true;				//Can allways edit own entry
	public $usertable = 'user';			//Table with users to get username from
	public $sortable = false;			//Passed to sqledit, 1 to pass true, if set to true it will be overwritten by editrights if set
	public $editdata = array();			//Passed to sqledit
	public $adddate = true;				//Add Date
	public $addchange = false;			//Add Changes
	public $addchangetext = true;			//Add Changes Texts when present in auto changes array
	public $protectuser = false;			//Right IDs a user can have, then users that dont have cannot change his entries
	
	public $prefunctions = false;			//Text to add for functions field
	public $addcaption = '<br><br>';		//Add to caption if present

	public $seperator = false;			//Entry Seperator
	public $pretext = false;			//Text that will preceed
	public $posttext = false;			//Text that will be appended
	public $admintext = '';				//Admin Text, leave false to just display admin buttons

	public $text = false;				//Text..., can give an array to display a directory where the array is returned.
							//TABLE[field] contains all table values (no $!), SELECT[...] the return values of the query used, FUNCTION[...] some stuff kfa
	public $dirdata = array();			//Passed to directory
	public $dirselect = false;			//Query that is executed to get arrayselect, if false is given arraytable is copied to arrayselect, [ID] is replaced by real id, [TABLE] also and [USER]

	public $cols = 0;				//Amount of cols for a table (1 will create a table!)

	public $storage = false;			//Storage dir for galery

	public $imgfile = false;			//Php file that gets the image, will get defaultlink, $imgfileparameter, "&img_id=[ID]"
	public $imgfileparameter = '';			//See above
	public $imgfilesizeparameter = '';		//...
	public $imgcommentsizeparameter = false;	//OVerride filesizeparameter for comments
	public $linknewwindow = false;			//Open link in new window

	public $categories = array();			//Used to categorize the stuff, give an array 'field' => $object, where 'field' is a field in $table, and object is an selectparam, it's default must match 'field'. Instead of an selectparam, you can give an array that will be defaultet to a selectparam, or a string that will become a selectparams $data.
	public $comments = false;			//String with comment table or array table => table name => name
	public $savedelete = false;			//Use Savedelete

	public $cataddlink = '';			//Add to link for categories

	public $showtable = 'mod_CreateNewsTemplateA';	//Leave if you dont know :|
	public $polltable = false;			//Array with table for poll_entries, poll_votes
	public $callback = false;			//Callback function for Templates
	public $callback_late = false;			//Late callback function, given $data, arrayselect, arraytable, functions
	public $callback_select = false;		//Late callback too but before replace arrays are build so you can change sql results
	public $callback_edit = false;			//Callback function that runs over the sqledit object before we start or the dir object if apropriate
}

class galerystorage
{
	public $sql = false;				//SQL Connection
	public $table = false;				//Table
	public $defaults = array();			//Array with default data, to insert into db
	public $filename = false;			//Field in table that will contain the filename
	public $storage = false;			//Storage directory
	public $targetstorage = false;			//Target Storage
	public $sqlfield = false;			//Set to a field name to store data in sql table instead of target_storage, files are deleted then
	public $select = false;				//May give an array with valid filenames that will be added, if no array is given all files are added
	public $userinput = array();			//User inputs that will be added to sql db, give 'field_name' => [Input Tag] where name must be field_name
}

function LoadGaleryStorage($data)
{
	mod_doDefaults($data);
	if ($data->targetstorage === false) $data->targetstorage = $data->storage;
	if (substr($data->storage, -1) != '/') $data->storage .= '/';
	if (substr($data->targetstorage, -1) != '/') $data->targetstorage .= '/';
	if (($dir = opendir($data->storage)) === false) trigger_error('Could not read storage directory', E_USER_ERROR);
	if (!file_exists($data->targetstorage)) trigger_error('Target Storage does not exist', E_USER_ERROR);
	while (($file = readdir($dir)) !== false)
	{
		if (str_replace('.', '', $file) != '' && !is_numeric($file))
		{
			if (is_array($data->select) && !in_array(basename($file), $data->select)) continue;

			if ($data->filename !== false) $data->defaults[$data->filename] = basename($file);
			if ($data->sqlfield !== false) if (($data->defaults[$data->sqlfield] = file_get_contents($data->storage . $file)) === false) trigger_error('Could not read file', E_USER_ERROR);
			$query = "INSERT INTO `" . mysql_escape_string($data->table) . "` (" .
				implode(',', mod_EscapeArray(array_keys($data->defaults), '`', 'mysql_escape_string')) .
				') VALUES (' . implode(',', mod_EscapeArray($data->defaults, '"', 'mysql_escape_string')) . ')';
			mod_mysql_querya($query, $data->sql);
			if ($data->sqlfield === false)
			{
				$id = mysql_insert_id($data->sql);
				rename($data->storage . $file, $data->targetstorage . $id);
			}
			else
			{
				unlink($data->storage . $file);
			}
		}
	}
	closedir($dir);
}

$mod_dwGaleryStorageCount = 0;
function CreateGaleryStorage($data)
{
	global $mod_dwGaleryStorageCount, $modules_defaults, $mod_txt;
	mod_doDefaults($data);

	if (isset($_REQUEST['mod_galstore_count'])) echo $_REQUEST['mod_galstore_count'] . $mod_txt['std_load_ok'];
	if (isset($_REQUEST["mod_galstore$mod_dwGaleryStorageCount"]))
	{
		foreach ($_REQUEST["mod_galstore$mod_dwGaleryStorageCount"] as $file => $tmp)
		{
			$data->select[] = $file;
		}
		foreach ($data->userinput as $field => $tmp)
		{
			$data->defaults[$field] = $_REQUEST[$field];
		}
		LoadGaleryStorage($data);

		if (isset($modules_defaults['mod_redir_changes']) && $modules_defaults['mod_redir_changes'])
		{
			$_REQUEST['mod_galstore_count'] = count($data->select);
			mod_redir_changes(array('mod_res'));
		}

		echo '<br>', count($data->select), $mod_txt['std_load_ok'];
	}

	echo mod_linkToForm($modules_defaults['defaultlink']);

	echo implode('<br>', $data->userinput);
	echo '<br>';

	if (substr($data->storage, -1) != '/') $data->storage .= '/';
	if (($dir = opendir($data->storage)) === false) trigger_error('Could not read storage directory', E_USER_ERROR);
	$outtable = array();
	while (($file = readdir($dir)) !== false)
	{
		if (str_replace('.', '', $file) != '' && !is_numeric($file))
		{
			$outtable[] = array('chkbox' => "<input type='checkbox' name='mod_galstore$mod_dwGaleryStorageCount" . '[' . htmlspecialchars($file) . "]' checked>", 'name' => $file);
		}
	}

	CreateTableA(array('data' => $outtable, 'sql' => $data->sql, 'width' => '90%', 'sortable' => false, 'title' => 'Images', 'inTds' => array('chkbox' => 'width=22'), 'repeatHeader' => -1));

	echo '<br><input type=submit value="' . htmlspecialchars($mod_txt['std_load']) . '"></form>';

	$mod_dwGaleryStorageCount++;
}

function mod_newstemplate_forum(&$data)
{
	global $userdata, $mod_dwDirectoryInstance, $modules_defaults, $mod_txt;
	if (isset($modules_defaults['user_data_config']) && isset($userdata['data']['mod_config']['forum_sort'])) $data->template_parameter['sort'] = $userdata['data']['mod_config']['forum_sort'];
	if (isset($modules_defaults['user_data_config']) && isset($userdata['data']['mod_config']['forum_display'])) $data->template_parameter['display'] = $userdata['data']['mod_config']['forum_display'];

	if (!isset($data->template_parameter['sort'])) $data->template_parameter['sort'] = 1;
	if (!isset($data->template_parameter['display'])) $data->template_parameter['display'] = 0;

	$esTable = mysql_escape_string($data->table);

	if ($data->template_parameter['sort'] == 0)
	{
		if (mod_user_defaultcallback($data->editrights) === true)
		{
			$data->sortable = 1;
		}
		else
		{
			$data->sortable = array("mod_tmproottable.user_id = $userdata[id]");
		}
	}
	else
	{
		$data->sortable = "IF(`$esTable`.thread>0,1,0) DESC, `$esTable`.timestamp " . ($data->template_parameter['sort'] == 1 ? 'DESC' : 'ASC');
	}

	$data->editdata['sqljoin'] = "LEFT JOIN `$esTable` AS mod_tmproottable ON `$esTable`.root = mod_tmproottable.id";
	if (mod_user_defaultcallback($data->editrights) !== true)
	{
		if (!isset($_REQUEST["mod_dirsetroot$mod_dwDirectoryInstance"]) && !isset($_REQUEST["mod_dirroot$mod_dwDirectoryInstance"])) $data->requirerights = -1;
		else
		{
			$query = "SELECT user_id, thread FROM `$esTable` WHERE id = " . intval(isset($_REQUEST["mod_dirsetroot$mod_dwDirectoryInstance"]) ? $_REQUEST["mod_dirsetroot$mod_dwDirectoryInstance"] : $_REQUEST["mod_dirroot$mod_dwDirectoryInstance"]);
			$result = mod_mysql_querya($query, $data->sql);
			if (!($tmp = mysql_fetch_assoc($result)) || ($tmp['user_id'] != $userdata['id'] && $tmp['thread'] < 2)) $data->requirerights = -1;
		}
	}

	$data->text = array($mod_txt['std_forum_forum'] => '');
}

function mod_Newstemplate_forum_relA($index)
{
	global $mod_dwDirectoryInstance, $mod_forum_threadids;
	return(isset($_POST[$index . 'root']) && in_array($_POST[$index . 'root'], $mod_forum_threadids[$mod_dwDirectoryInstance]));
}

function mod_Newstemplate_forum_rel($data)
{
	global $userdata, $mod_dwDirectoryInstance, $mod_forum_threadids, $mod_txt;
	$retVal = array();
	$esTable = mysql_escape_string($data->table);

	$wherepart = array("`$esTable`.thread > 0");
	$disable = array();

	if ($data->savedelete)
	{
		$wherepart[] = "`$esTable`.deleted = 0";
	}
	if ($right_false = (mod_user_defaultcallback($data->editrights) !== true))
	{
		$disable[] = "(`$esTable`.user_id != $userdata[id] AND `$esTable`.thread < 2)";
		$disable[] = -1;
	}

	$retVal['root'] = array('name' => 'Root', 'type' => 'root', 'rootdefaults' => $wherepart, 'rootjoin' => true, 'rootdisable' => $disable, 'rootname' => $mod_txt['std_forum_forum']);
	$retVal['thread'] = array('name' => 'Thread', 'type' => 'select', 'options' => array(0 => 'Post', 1 => 'Thread', 2 => 'Public Thread', 3 => 'Public Thread with Subthreads'));

	if ($right_false)
	{
		$query = "SELECT id FROM `$esTable` WHERE thread = 3";
		$mod_forum_threadids[$mod_dwDirectoryInstance] = mod_Query2Array($query, $data->sql, 0);
		echo "<script>mod_forum_threadids[$mod_dwDirectoryInstance] = [" . implode(',', $mod_forum_threadids[$mod_dwDirectoryInstance]) . '];</script>';

		$retVal['thread'] = array(
			'multipleinstance' => $retVal['thread'],
			array('check_php' => 'mod_Newstemplate_forum_relA', 'check_java' => "mod_InArray(document.getElementById('mod_forumrecheck_$mod_dwDirectoryInstance').value, mod_forum_threadids[$mod_dwDirectoryInstance])"),
			array('options' => array(0 => 'Post'))
		);
		$retVal['root']['recheckinstance'] = "mod_forumrecheck_$mod_dwDirectoryInstance";
	}

	return($retVal);
}

function mod_Newstemplate_forum_late(&$data, $arraytable, $arrayselect, $functions)
{
	global $mod_txt, $session;

	if (isset($session))
	{
		if (!isset($session['mod_forum_views'])) $session['mod_forum_views'] = array();

		if (!isset($session['mod_forum_views'][$arraytable['root']]))
		{
			$query = "UPDATE `" . mysql_escape_string($data->table) . "` SET views = views + 1 WHERE id = " . intval($arraytable['root']);
			mod_mysql_querya($query, $data->sql);
			$session['mod_forum_views'][$arraytable['root']] = 1;
		}
	}

	$textpart = $arraytable['thread'] && 0 ? '' : '<tr><td style="padding-left:10px;">TABLE[text]</td></tr>';

	if ($data->template_parameter['display'] == 0)
	{
		$data->text = array(
			$mod_txt['std_forum_forum'] => 'FUNCTION[name]</td></tr>' . $textpart . '</table></div>',
			$mod_txt['std_forum_user'] => 'SELECT[User] [EMAIL]<br><i style="font-size:90%;">(SELECT[Time])</i>',
			$mod_txt['std_forum_views'] => 'SELECT[Views]',
			$mod_txt['std_forum_posts'] => 'SELECT[Posts]',
			$mod_txt['std_forum_last'] => 'SELECT[Last]'
		);
	}
	else
	{
		if ($arraytable['thread'])
		{
			$threadpart = "$mod_txt[std_forum_views]: SELECT[Views] &nbsp; - &nbsp; $mod_txt[std_forum_posts]: SELECT[Posts] &nbsp; - &nbsp; $mod_txt[std_forum_last]: SELECT[Last]";
		}
		else
		{
			$threadpart = '';
		}
		$data->text = array(
			$mod_txt['std_forum_forum'] => '<hr>FUNCTION[name] &nbsp; - &nbsp; SELECT[User] [EMAIL] &nbsp; - &nbsp; (<i style="font-size:90%;"> SELECT[Time]</i>)</td></tr><tr><td colspan=3 style="padding-left:10px;">' .
				"$threadpart" . "</td></tr>$textpart</table></div>"
		);
	}
}

function mod_CreateNewsTemplateB($id, $name, $data)
{
	global $mod_dirsubedit, $mod_CreateNewsTemplateA_data;
	$query = "SELECT * FROM `" . mysql_escape_string($data->table) . "` WHERE id = $id";
	$tmp = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));
	if ($mod_CreateNewsTemplateA_data->dirselect === false) $tmp2 = $tmp;
	else
	{
		$query = str_replace(array('[ID]', '[TABLE]', '[USER]'), array($id, mysql_escape_string($mod_CreateNewsTemplateA_data->table), mysql_escape_string($mod_CreateNewsTemplateA_data->usertable)), $mod_CreateNewsTemplateA_data->dirselect);
		$tmp2 = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));
	}
	return(mod_CreateNewsTemplateA($tmp, $tmp2, array('edit' => $mod_dirsubedit[$id], 'name' => $name), 0, $data->edit));
}

$mod_CreateNewsTemplateA_col = 1;
function mod_CreateNewsTemplateA($arraytable, $arrayselect, $functions, $first, $editdata = false)
{
	global $userdata, $mod_CreateNewsTemplateA_data, $mod_CreateNewsTemplateA_col, $modules_defaults, $mod_txt, $dwEditInstance, $mod_use;
	$data = $mod_CreateNewsTemplateA_data;

	if ($first === -1)
	{
		$retVal = '';
		if ($data->cols >= 1 && $mod_CreateNewsTemplateA_col > 1)
		{
			for ($i = $mod_CreateNewsTemplateA_col;$i < $data->cols;$i++)
			{
				$retVal .= '<td>&nbsp;</td>';
			}
		}
		$retVal .= $data->posttext;
		return($retVal);
	}

	if (isset($arraytable['caption']) && $arraytable['caption'] != '') $arraytable['caption'] .= $data->addcaption;

	if ($editdata !== false && $editdata->changes !== false)
	{
		$tmpChanges = mod_showChanges($editdata->sqltablename, $arraytable['id'], isset($mod_use) ? $mod_use->user : false, $editdata->changetype == 2, false, $editdata->sql);
		if ($tmpChanges != '')
		{
			$tmpChanges = '<hr><i>' . $tmpChanges . '</i>';
			$arraytable[$editdata->changes] .= $tmpChanges;
			if (isset($arrayselect['text'])) $arrayselect['text'] .= $tmpChanges;
		}
	}

	$replace1 = $replace2 = array();

	if ($data->callback_select !== false)
	{
		$f_tmp = $data->callback_select;
		$f_tmp($data, $arraytable, $arrayselect, $functions);
	}

	$arrays = array('arraytable' => 'TABLE', 'arrayselect' => 'SELECT', 'functions' => 'FUNCTION');
	foreach ($arrays as $array => $name)
	{
		foreach ($$array AS $index => $val)
		{
			$replace1[] = $name . '[' . $index . ']';
			$replace2[] = mod_cr2br($val);
		}
	}

	if ($data->comments !== false && !isset($_REQUEST["mod_comment$dwEditInstance"]))
	{
		$query = "SELECT COUNT(*) FROM `" . mysql_escape_string($data->comments['table']) . "` WHERE ref = $arraytable[id] AND `table` = '" . mysql_escape_string($data->table) . "'";
		$count = mysql_result(mod_mysql_querya($query, $data->sql), 0);
		$comments = (count($functions) ? '<br>' : '') . "<a href='$data->defaultlink$data->cataddlink&mod_comment$dwEditInstance=$arraytable[id]'>" . (isset($data->comments['name']) ? $data->comments['name'] : $mod_txt['std_comments']) . " ($count)</a>";
		$functions[] = $comments;
	}

	$replace1[] = '[FUNCTIONS]';
	$replace2[] = (count($functions) ? $data->prefunctions : '') . implode('&nbsp;', $functions);
	if ($data->adduser)
	{
		if ($arraytable['user_id'] && $data->adduser !== 2)
		{
			$user = $arrayselect['User'];
		}
		else if ($data->adduser === true || $data->adduser === 2)
		{
			$user = $arraytable['name'];
		}
		else
		{
			$user = '';
		}
		$replace1[] = '[USER]';
		$replace2[] = $user;
	}

	if ($data->addemail)
	{
		$esUser = mysql_escape_string($data->usertable);
		if ($data->addemail !== 1 && isset($userdata['email']) && $data->adduser && $arraytable['user_id'])
		{
			$query = "SELECT email FROM `$esUser` WHERE id = $arraytable[user_id]";
			$email = mysql_result(mod_mysql_querya($query, $data->sql), 0);
		}

		if (!isset($email))
		{
			$email = $data->addemail === 2 ? '' : $arraytable['email'];
		}
		$replace1[] = '[EMAIL]';
		$replace2[] = $email == '' ? '' : "<i>(<a href='mailto:$email'>$email</a>)</i>";
	}

	if ($data->imgfile !== false)
	{
		$replace1[] = '[IMAGE]';
		$replace2[] = "<a " . ($data->linknewwindow ? 'target="_blanc" ' : '') . "href='$data->imgfile$modules_defaults[defaultlink]$data->imgfileparameter&img_id=$arraytable[id]'>
					<img src='$data->imgfile$modules_defaults[defaultlink]$data->imgfileparameter" . ($data->comments !== false && isset($_REQUEST["mod_comment$dwEditInstance"]) && $data->imgcommentsizeparameter !== false ? $data->imgcommentsizeparameter: $data->imgfilesizeparameter) . "&img_id=$arraytable[id]&mod_use_galview=1'
					style='border:2px solid black;' onMouseOver='this.style.border=\"2px solid orange\";' onMouseOut='this.style.border=\"2px solid black\";'></a>";
	}

	if ($data->callback_late !== false)
	{
		$f_tmp = $data->callback_late;
		$f_tmp($data, $arraytable, $arrayselect, $functions);
	}
	$retVal = str_replace($replace1, $replace2, $data->text);

	if (!is_array($data->text))
	{
		if ($data->cols >= 1)
		{
			$retVal = ($first === true ? $data->pretext : '') . ($mod_CreateNewsTemplateA_col == 1 ? '<tr>' : '') . '<td valign=top width=' . round(100 / $data->cols) . '%>' . $retVal;
		}
		else
		{
			$retVal = ($first === false ? $data->seperator : $data->pretext) . $retVal;
		}

		if ($data->editrights === false || mod_user_defaultcallback($data->editrights) || ($data->editown && $arraytable['user_id'] == $userdata['id'] && $userdata['id']))
		{
			if ($data->admintext === false)
			{
				$retVal .= implode('&nbsp;', $functions);
			}
			else
			{
				$retVal .= str_replace($replace1, $replace2, $data->admintext);
			}
		}

		if ($data->cols >= 1)
		{
			$retVal .= '</td>';
			if ($mod_CreateNewsTemplateA_col++ == $data->cols)
			{
				$mod_CreateNewsTemplateA_col = 1;
				$retVal .= '</tr>';
			}
		}
	}

	return($retVal);
}

function CreateNewsTemplate($data)
{
	global $userdata, $mod_templates, $mod_CreateNewsTemplateA_data, $mod_CreateNewsTemplateA_col, $dwEditInstance, $mod_txt, $modules_defaults;
	mod_doDefaults($data);

	$table = $mod_templates[$data->template]['table'];

	$edit = new sqledit;

	if (isset($mod_templates[$data->template]['editdata'])) $data->editdata = array_merge($mod_templates[$data->template]['editdata'], $data->editdata);
	if (isset($mod_templates[$data->template]['dirdata'])) $data->dirdata = array_merge($mod_templates[$data->template]['dirdata'], $data->dirdata);

	$edit->defaultlink = $data->defaultlink;

	$esTable = mysql_escape_string($data->table);

	$edit->sql = $data->sql;
	$edit->sqltablename = $data->table;

	if (!$data->adduser)
	{
		$data->editown = false;
	}
	if ($data->editrights === -1) $data->editrights = $data->requirerights;

	if (is_string($data->comments)) $data->comments = array('table' => 'comments');
	if ($data->comments !== false)
	{
		checkTable($mod_templates['comments']['table'], $data->comments['table'], $data->sql);
	}

	$edit->relations = array_merge($edit->relations, $mod_templates[$data->template]['relations']);
	
	if ($data->storage !== false && isset($edit->relations['file'])) $edit->relations['file']['storage'] = $data->storage;
	
	if (isset($mod_templates[$data->template]['vars'])) mod_doDefaults($data, $mod_templates[$data->template]['vars']);
	if (isset($mod_templates[$data->template]['forcevars'])) mod_doDefaults($data, $mod_templates[$data->template]['forcevars'], true);

	if ($data->callback !== false)
	{
		$tmpfuncname = $data->callback;
		$tmpfuncname($data);
	}

	mod_doDefaults($edit, $data->editdata, true);

	if ($data->adduser && $userdata['id'] == 0 && $data->adduser !== 1)
	{
		$table['name'] = array('text' => 0);
		$edit->relations['name'] = array('name' => 'Name', 'force' => true);
	}

	if ($data->addemail && $data->addemail !== 2 && (!isset($userdata['email']) || $data->addemail === 1))
	{
		$table['email'] = array('text' => 0);
		$edit->relations['email'] = array('name' => 'E-Mail');
	}

	if ($data->editrights == -2) $data->editrights = $userdata['id'] == 0 ? -1 : false;
	if ($data->requirerights == -2) $data->requirerights = $userdata['id'] == 0 ? -1 : false;

	$edit->sortable = $data->sortable;
	$edit->showtable = $data->showtable;

	if ($data->adduser)
	{
		$esUser = mysql_escape_string($data->usertable);
		$edit->justadddefaults['user_id'] = $userdata['id'];
		$edit->relations['user_id'] = array('type' => 'virtual', 'sql' => "`$esUser`.username", 'name' => 'User');
		$edit->sqljoin .= " LEFT JOIN `$esUser` ON `$esUser`.id = `$esTable`.user_id";
		$table['user_id'] = array('int' => 11);
	}
	else
	{
		$data->editown = false;
	}

	$edit->adddate = $data->adddate;
	$edit->addchange = $data->addchange;
	if ($data->adddate && !isset($table['timestamp']))
	{
		$table['timestamp'] = array('int' => 11, 'index' => 0);
	}
	if ($data->addchange && !isset($table['changed']))
	{
		$table['changed'] = array('int' => 11, 'default' => 0);
	}
	if ($data->savedelete && !isset($table['deleted']))
	{
		$table['deleted'] = array('int' => 11, 'index' => 0);
	}
	if ($edit->sortable === false && $data->adddate)
	{
		$edit->sortable = '`' . $esTable . '`.' . ($data->addchange ? 'changed' : 'timestamp') . ' DESC';
	}

	foreach ($data->categories as $field => $category)
	{
		if (!is_object($category))
		{
			$tmpcat = $category;
			$category = new selectparam;
			if (is_array($tmpcat)) mod_doDefaults($category, $tmpcat, true);
			else $category->data = $tmpcat;
		}

		$tmpval = CreateSelectParam($category);
		if ($data->comments === false || !isset($_REQUEST["mod_comment$dwEditInstance"]))
		{
			if (is_array($tmpcat) && isset($tmpcat['caption'])) echo $tmpcat['caption'] . '&nbsp;';
			echo $tmpval, ' &nbsp; ';
		}
		$data->cataddlink .= $category->addlink;

		if (is_array($tmpcat) && isset($tmpcat['relation']))
		{
			$edit->sqlwhere .= ' AND `' . mysql_escape_string($field) . '` = "' . mysql_escape_string($category->default) . '"';
			$edit->relations[$field] = $tmpcat['relation'];
		}
		else
		{
			$edit->adddefaults[$field] = $category->default;
		}

		if (isset($tmpcat))
		{
			unset ($category);
			unset ($tmpcat);
		}
	}

	$edit->defaultlink .= $data->cataddlink;

	if (count($edit->adddefaults) && $edit->sqlwhere == 'TRUE') $edit->sqlwhere = '';

	$mod_CreateNewsTemplateA_data = $data;
	$edit->addable = ($data->requirerights === false || mod_user_defaultcallback($data->requirerights));

	if ($data->editrights === false || mod_user_defaultcallback($data->editrights))
	{
		$edit->editable = true;
	}
	else if ($data->editown && $userdata['id'])
	{
		$edit->editable = "`$esTable`.user_id > 0 && `$esTable`.user_id = $userdata[id]";
	}
	else
	{
		$edit->editable = false;
	}
	$edit->deleteable = $edit->editable;
	$edit->pagecols = $data->cols;
	$edit->savedelete = $data->savedelete;
	if ($edit->sortable === 1)
	{
		$edit->sortable = true;
	}
	else if ($edit->sortable === true)
	{
		if (is_string($edit->editable)) $edit->sortable = array($edit->editable);
		else $edit->sortable = $edit->editable;
	}

	checkTable($table, $data->table);

	if ($data->comments !== false && isset($_REQUEST["mod_comment$dwEditInstance"]))
	{
		if (mod_checkTableId($data->table, $id = intval($_REQUEST["mod_comment$dwEditInstance"]), $data->sql, $data->savedelete))
		{
			$showcomments = $id;
			$edit->sqlforcewhere .= "`$esTable`.id = $id";
			$edit->forceedit = false;
			$edit->editable = false;
			$edit->deleteable = false;
			$edit->addable = false;
			$edit->noaction = true;
		}
	}

	if ($data->template == 'polls')
	{
		$esPollTable = mysql_escape_string($data->polltable[0]);
		$edit->relations['name']['link'] = $data->defaultlink . $data->cataddlink . "&mod_poll$dwEditInstance=[ID]";
		$edit->relations['selections']['sqllink'] = $data->polltable[0];
		$edit->relations['count'] = array('name' => $mod_txt['std_poll_select'], 'type' => 'virtual', 'sql' => "COUNT(DISTINCT `$esPollTable`.id)");
		$edit->sqljoin .= " LEFT JOIN `$esPollTable` ON `$esPollTable`.poll_id = `$esTable`.id";
		
		if (isset($_REQUEST["mod_poll$dwEditInstance"]) && !mod_checkTableId($data->table, $pollid = intval($_REQUEST["mod_poll$dwEditInstance"]))) unset($pollid);

		$where = array();
		if ($edit->sqlwhere != '') $where[] = $edit->sqlwhere;
		if ($edit->sqlforcewhere !== false) $where[] = $edit->sqlforcewhere;
		if ($edit->sqlwhere == '')
		{
			foreach ($edit->adddefaults AS $index => $default)
			{
				$where[] = '`' . mysql_escape_string($index) . '` = "' . mysql_escape_string($default) . '"';
			}
		}
		$where = implode(' AND ', $where);

		if (isset($pollid))
		{
			$query = "SELECT COUNT(*) FROM `$esTable` WHERE $where AND id = $pollid";
			if (mysql_result(mod_mysql_querya($query, $data->sql), 0) == 0) unset($pollid);
		}

		if (!isset($pollid))
		{
			$query = "SELECT id FROM `$esTable` WHERE $where" . ($data->savedelete ? ' AND deleted = 0' : '') . ' ORDER BY timestamp DESC LIMIT 1';
			$result = mod_mysql_querya($query, $data->sql);
			if (mysql_num_rows($result)) $pollid = mysql_result($result, 0);
		}

		if (isset($pollid));
		{
			$poll = new poll;
			$poll->sql = $data->sql;
			$poll->table = $data->polltable;
			$poll->title = mod_getTableNameFromId($data->table, $pollid);
			$poll->defaultlink = $data->defaultlink . $data->cataddlink . "&mod_poll$dwEditInstance=$pollid";
			$poll->editable = mod_user_defaultcallback($data->editrights);
			$poll->savedelete = $data->savedelete;
			$poll->poll_id = $pollid;
			$tmpEditInstance = $dwEditInstance++;
			CreatePoll($poll);
			$dwEditInstance = $tmpEditInstance;
			unset($poll);
		}
	}

	if ($edit->action === false && isset($modules_defaults['action_table']) && isset($modules_defaults['action_defaults']) && isset($modules_defaults['action_defaults'][$edit->sqltablename]))
	{
		$edit->action = array('data' => $edit->adddefaults);
	}
	if ($data->addchangetext && isset($modules_defaults['changes_defaults']) && isset($modules_defaults['changes_defaults'][$data->template])) $edit->changes = $modules_defaults['changes_defaults'][$data->template];

	if (isset($edit->relations['mod_template_callback']))
	{
		$tmpArray = call_user_func($edit->relations['mod_template_callback'], $data);
		unset($edit->relations['mod_template_callback']);
		$edit->relations += $tmpArray;
	}

	if ($data->protectuser !== false && mod_user_defaultcallback($data->protectuser) !== true && $data->adduser)
	{
		$tmprights = mod_collapseRightId($data->protectuser);
		if ($edit->editable || is_string($edit->editable)) $edit->editable = (is_string($edit->editable) ? "($edit->editable) AND " : '') . "(IFNULL(`$esUser`.rights, 0) & $tmprights) = 0";
		if ($edit->deleteable || is_string($edit->deleteable)) $edit->deleteable = (is_string($edit->deleteable) ? "($edit->deleteable) AND " : '') . "(IFNULL(`$esUser`.rights,0) & $tmprights) = 0";
	}

	if (is_array($data->text))
	{
		$dir = new displaydirectory;
		$dir->sql = $data->sql;
		$dir->table = $data->table;
		$dir->callback_function = $data->showtable;
		$dir->defaultlink = $data->defaultlink;
		$dir->savedelete = $data->savedelete;
		if (is_string($edit->sortable)) $dir->sort = array($edit->sortable);
		mod_doDefaults($dir, $data->dirdata, true);
		$dir->edit = $edit;
		
		if ($data->callback_edit !== false)
		{
			$tmp_func = $data->callback_edit;
			$tmp_func($dir);
		}
		CreateDirectory($dir);
	}
	else
	{
		if ($data->callback_edit !== false)
		{
			$tmp_func = $data->callback_edit;
			$tmp_func($edit);
		}
		CreateSqlEdit($edit);
	}

	if (isset($tmpEditInstance)) $dwEditInstance++;
	unset($edit);

	if (isset($showcomments))
	{
		$comments = new newstemplate;
		$comments->template = 'comments';
		$comments->table = $data->comments['table'];
		$comments->requirerights = false;
		$comments->editrights = $data->editrights;
		$comments->editown = true;
		$comments->adduser = $data->adduser ? 1 : 0;
		$comments->editdata['name'] = $mod_txt['std_comment'];
		$comments->editdata['title'] = $mod_txt['std_comments'];
		$comments->editdata['savedelete'] = $data->savedelete;
		if (isset($data->comments['commentdata']))
		{
			mod_doDefaults($comments, $data->comments['commentdata'], true);
		}
		$comments->editdata['adddefaults'] = array('table' => $data->table, 'ref' => $showcomments);
		$comments->editdata['sqlwhere'] = '';
		$comments->defaultlink = $data->defaultlink . $data->cataddlink . "&mod_comment" . ($dwEditInstance - 1) . "=$showcomments";

		if (!isset($comments->editdata['action']) && isset($modules_defaults['action_table']) && isset($modules_defaults['action_defaults']) && isset($modules_defaults['action_defaults'][$data->comments['table']]))
		{
			$comments->editdata['action'] = array('data' => array('table' => $data->table, 'ref' => $showcomments));
		}

		echo "<br><b style='font-size:130%;'>$mod_txt[std_comments]:</b><br><br><table width=80%><tr><td>";
		CreateNewsTemplate($comments);
		echo '</td></tr></table>';
		unset($comments);
	}
}

class poll
{
	public $sql = false;			//SQL Connection
	public $table = false;			//Attay(poll_entries, votes)
	public $title = false;			//...
	public $full = true;			//Leave true for full poll, otherwise give a string with a link to a page to display after a vote, false for no link
	public $editable = false;		//...
	public $defaultlink = false;		//...
	public $savedelete = false;		//...
	public $poll_id = false;		//... / Leave false for last poll
}

function CreatePoll($data)
{
	global $mod_txt, $userdata;
	mod_doDefaults($data);

	$esPollTable = mysql_escape_string($data->table[0]);
	$esVotes = mysql_escape_string($data->table[1]);

	if ($data->poll_id === false)
	{
		$query = "SELECT id FROM `$esPollTable`" . ($data->savedelete ? ' WHERE deleted = 0' : '') . ' ORDER BY timestamp DESC LIMIT 1';
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result) == 0) return;
		$data->poll_id = mysql_result($result, 0);
		mysql_free_result($result);
	}

	$table = array(
		'name' => array('text' => 0),
		'poll_id' => array('int' => 11, 'index' => 0)
	);
	checkTable($table, $data->table[0]);
	$table = array(
		'user_id' => array('int' => 11, 'index' => 0),
		'timestamp' => array('int' => 11, 'index' => 0),
		'poll_entry_id' => array('int' => 11, 'index' => 0)
	);
	checkTable($table, $data->table[1]);

	if (isset($_REQUEST["mod_vote$data->poll_id"]) && mod_checkTableId($data->table[0], $id = intval($_REQUEST["mod_vote$data->poll_id"])))
	{
		$time = time();
		$query = "INSERT INTO `$esVotes` (user_id, timestamp, poll_entry_id) VALUES ($userdata[id], $time, $id)";
		mod_mysql_querya($query, $data->sql);

		$_REQUEST["mod_poll_result$data->poll_id"] = 1 + intval($userdata['id'] > 0);
		mod_redir_changes(array('mod_vote'));
	}

	$edit = new sqledit;
	$edit->sqltablename = $data->table[0];
	$edit->title = $mod_txt['std_poll']. ': ' . $data->title;
	$edit->addable = $edit->editable = $edit->deleteable = $data->editable;
	$edit->savedelete = $data->savedelete;
	$edit->sortable = false;
	$edit->sqlwhere = '';
	$edit->adddefaults['poll_id'] = $data->poll_id;
	$edit->defaultlink = $data->defaultlink;

	$edit->relations = array(
		'name' => array('name' => $mod_txt['std_poll_select'], 'force' => true, 'nodual' => "poll_id = $data->poll_id")
	);

	if (isset($_REQUEST["mod_poll_result$data->poll_id"]))
	{
		$edit->relations['votes'] = array('name' => $mod_txt['std_poll_votes'], 'sql' => "COUNT(DISTINCT `$esVotes`.id)", 'type' => 'virtual');
		$edit->sqljoin .= " LEFT JOIN `$esVotes` ON `$esVotes`.poll_entry_id = `$esPollTable`.id";
		if ($_REQUEST["mod_poll_result$data->poll_id"] == 2)
			$edit->sqljoin .= " AND `$esVotes`.user_id != 0 AND ((SELECT COUNT(*) FROM `$esVotes` AS `esVotesA` WHERE `esVotesA`.user_id = `$esVotes`.user_id AND `esVotesA`.timestamp > `$esVotes`.timestamp) = 0)";
	}
	else
	{
		$edit->relations['name']['link'] = $data->defaultlink . "&mod_vote$data->poll_id=[ID]";
	}

	$edit->name = $mod_txt['std_poll_select'];
	CreateSqlEdit($edit);

	$btns = array();
	if (!isset($_REQUEST["mod_poll_result$data->poll_id"]) || $_REQUEST["mod_poll_result$data->poll_id"] != 2)
	{
		$btns[] = "<a href='$data->defaultlink&mod_poll_result$data->poll_id=2'>$mod_txt[std_poll_repr]</a>";
	}

	if (!isset($_REQUEST["mod_poll_result$data->poll_id"]) || $_REQUEST["mod_poll_result$data->poll_id"] == 2)
	{
		$btns[] = "<a href='$data->defaultlink&mod_poll_result$data->poll_id=1'>$mod_txt[std_poll_nrepr]</a>";
	}
	if (count($btns)) echo implode('&nbsp;-&nbsp;', $btns) . '<br>';

	if ($data->full) echo '<br><hr width=90%><br>';
}

?>
