<?php

require_once('mod_sqledit.php');

class user
{
	public $sql = false;			//SQL Connection
	public $table = false;			//User Table Name
	public $sessiontable = false;		//Session Table Name
	public $sessiondata = false;		//Store $session var session table, supply SaveSession() (loading automaticly)
	public $alwayssession = false;		//Always Create a session even if not logged in
	public $relations = array();		//Relations added in Sqledit
	public $grouprelations = array();	//Same for groups
	public $adddefaults = array();		//Default in sql edit
	public $groupadddefaults = array();	//Same for groups again
	public $usercallback = false;		//Callbackfunction before CreateSqlEdit is called
	public $groupcallback = false;		//For Groups again
	public $editdata = array();		//Will be defaulted to user sql edit
	public $relationtype = 1;		//Where to add custom relations? 1: at the end, -1: at the beginning
	public $rights = false;			//Table name for rights, true for Simple Integer, false for no right management
	public $defaultlink = false;		//Default Link
	public $adddefaultlink = array();	//Array with $_REQUEST indexes to auto add (only for CreateUserLogin)
	public $permissiondenied = false;	//Name of a callback function if permision denied or false for die()
	public $timeout = 1800;			//Timeout for login in seconds
	public $loginWidth = 20;		//Size of Login Inputs

	public $groups = false;			//Group Table name or false for no groups
	public $grouplinktable = false;		//Group Link Table Name
	public $static = false;			//Cannot add / delete user / groups
	public $groupingroup = true;		//Allow Groups to be groupmembers

	public $userdata = false;		//Store Variable $userdata['data'] in user db (Call SaveSession to store!)
	public $globaldata = false;		//SQL Table to store global variables in, save with savesession, will be loaded with createuserlogin, will be made public in $globaldata

	public $counter = false;		//Add A Counter in Global Data, Will increase when a session is created so use alwayssession!

	public $groupwhere = false;		//SQL Where Clause that is included in Group Edit
	public $protectuser = false;		//Set right IDs a user may not give while also protecting users with at least one of these ids from changes

	public $adminrights = array();		//Admin Rights that will make right checks default to true
	public $protectadminrights = array();	//Rights that wont be defaulted to true if an admin right is present
	public $protectadminuser = array();	//Protext the last user, that has a singe given right (array) from being deleted, set to true to copy adminrights

	public $deletecallback = false;		//Callback function called before user is delete given the user_id

	public $addlink = '';			//Return Value to add to links
	public $savedelete = false;		//Pass to SQL Edit

	public $ssllogin = false;		//Autoswitch to SSL Connection when logging in, true for autoswitch, 1 do ssllogin if not connection from localhost
	public $addemail = false;		//Add E-Mail, True to force

	public $register = false;		//Register User..., if set give a string that is appended to the url, when register user is clicked
	public $registerlogin = true;		//Auto login user that just registered
	public $changeonly = false;		//Set true To only change date but do not allow to register
	public $afterregister = array();	//Where to go after registration (Append to $_REQUEST)
	public $emailvalidate = false;		//Give an array ('table' => [table], 'link' => [LINK], after following that link you must call mod_uservalidate($user), can set 'sender', 'caption' and 'text' for mail
	public $activate = false;		//Set true if user must be activated in Useredit before they can login
	public $validatetimeout = 3600;		//Timeout in seconds how long you can validate an account
	public $resetpw = false;		//Allow User to request an email to reset his pw, give an array, 'table' => validate table, 'link1' => 'link parameter', 'link2' => 'url for mail'

	public $limitadmin = false;		//Limit admin rights to reset pw / change rights but no user_id (Set true to activate or the name of a right to override), set to -1 to limit independend of user
	public $limitfields = array('username', 'password', 'rights', 'groups'); //Fields that can still be edited when limitadmin is activated
	public $alias = false;			//Right required to alias user

	public $action = false;			//Action Array passes to checkAction if not false, if no type set table will become type, sql is passed through

	public $commongroup = false;		//Group everyone even not logged in will be added to
}

function mod_CreateRightsEdit_A()
{
	global $mod_CreateRightsEdit_Aval;

	$esRights = mysql_escape_string($mod_CreateRightsEdit_Aval->rights);

	$query = "SELECT right_id FROM `$esRights`";
	$ids = mod_Query2Array($query, $mod_CreateRightsEdit_Aval->sql, 'right_id');

	$i = 1;
	while (in_array($i, $ids)) $i*=2;

	return($i);
}

function mod_CreateRightsEdit_B($id)
{
	global $mod_CreateRightsEdit_Aval;

	$esTable = mysql_escape_string($mod_CreateRightsEdit_Aval->table);
	$esRights = mysql_escape_string($mod_CreateRightsEdit_Aval->rights);

	$query = "UPDATE `$mod_CreateRightsEdit_Aval->table` SET
		`$esTable`.rights = (`$esTable`.rights & (~(SELECT right_id FROM `$esRights` WHERE id = $id)))";
	mod_mysql_querya($query, $mod_CreateRightsEdit_Aval->sql);
	if ($mod_CreateRightsEdit_Aval->groups)
	{
		$esGroups = mysql_escape_string($mod_CreateRightsEdit_Aval->groups);

		$query = "UPDATE `$esGroups` SET
			`$esGroups`.rights = (`$esGroups`.rights & (~(SELECT right_id FROM `$esRights` WHERE id = $id)))";
		mod_mysql_querya($query, $mod_CreateRightsEdit_Aval->sql);
	}
}

function CreateRightsEdit($data)
{
	global $mod_CreateRightsEdit_Aval, $mod_txt;
	mod_doDefaults($data);

	if (!is_string($data->rights))
	{
		trigger_error('Rights must point to an SQL table name!');
	}

	checkTable('rights', $data->rights, $data->sql);

	$edit = new sqledit;
	$edit->title = $mod_txt['rights_title'];
	$edit->name = $mod_txt['rights_right'];
	$edit->sql = $data->sql;
	$edit->sqltablename = $data->rights;
	$mod_CreateRightsEdit_Aval = $data;
	$edit->deletecallback = 'mod_CreateRightsEdit_B';
	$edit->relations = array('name' => array('name' => $mod_txt['rights_right'], 'force' => true), 'right_id' => array('name' => 'ID', 'type' => 'hidden', 'default_callback' => 'mod_CreateRightsEdit_A'));
	$edit->sortable = 'right_id ASC';
	$edit->namefield = 'right';
	CreateSqlEdit($edit);
	unset($edit);
}

function CreateRightEdit_callback($a, $b, $name)
{
	global $mod_CreateRightEdit_Callbackval, $userdata, $mod_txt;

	$esRights = mysql_escape_string($mod_CreateRightEdit_Callbackval->rights);

	if (isset($mod_CreateRightEdit_Callbackval->mod_edituser) && isset($userdata) && $userdata['id'] && $userdata['id'] == $b && isset($mod_CreateRightEdit_Callbackval->protectuser))
	{
		$wherepart = "WHERE (`$esRights`.right_id & " . (intval($mod_CreateRightEdit_Callbackval->protectuser) & (~ intval($userdata['rights']))) . ") = 0";
	}
	else if (isset($mod_CreateRightEdit_Callbackval->protectuser) && $mod_CreateRightEdit_Callbackval->protectuser && (intval($mod_CreateRightEdit_Callbackval->protectuser) & intval($userdata['rights'])) != intval($mod_CreateRightEdit_Callbackval->protectuser))
	{
		$wherepart = "WHERE (`$esRights`.right_id & $mod_CreateRightEdit_Callbackval->protectuser) = 0";
	}
	else
	{
		$wherepart = '';
	}

	$query = "SELECT right_id, name FROM `$esRights` $wherepart ORDER BY name";
	if (isset($mod_CreateRightEdit_Callbackval->loginright) && $mod_CreateRightEdit_Callbackval->loginright)
	{
		$query = "(SELECT -100 AS right_id, 'Login' AS name) UNION ($query) ORDER BY name";
	}
	$result = mod_mysql_querya($query, $mod_CreateRightEdit_Callbackval->sql);
	$opt = array('', '');

	while ($tmp = mysql_fetch_assoc($result))
	{
		$tmp2 = $a < 0 ? (intval($tmp['right_id'] == -100)) : (($b && (intval($a) & $tmp['right_id']) == $tmp['right_id']) ? 1 : 0);
		$opt[$tmp2] .= "<option value=$tmp[right_id]>$tmp[name]</option>";
	}

	$list = new duallist;
	$list->data = $opt;
	$list->inputname = $name;
	$list->default = strlen($a) ? $a : 0;
	$list->desc = array($mod_txt['rights_available'], $mod_txt['rights_set']);
	$retVal = CreateFormDualList($list);
	unset($list);

	mysql_free_result($result);

	return($retVal);
}

function mod_CreateGroupEdit_callback($b, $a, $type, $inpname)
{
	global $mod_CreateRightEdit_Callbackval, $mod_txt;

	if ($a == 0)
	{
		$name = $mod_txt['user_new'];
	}
	else
	{
		$query = "SELECT " . ($type == 'user' ? 'username' : 'name') . " FROM `" . mysql_escape_string($type == 'user' ? $mod_CreateRightEdit_Callbackval->table : $mod_CreateRightEdit_Callbackval->groups) . "` WHERE id = " . intval($a);
		$name = mysql_result(mod_mysql_querya($query, $mod_CreateRightEdit_Callbackval->sql), 0);
	}

	$esGroups = mysql_escape_string($mod_CreateRightEdit_Callbackval->groups);
	$esTable = mysql_escape_string($mod_CreateRightEdit_Callbackval->table);
	$esLink = mysql_escape_string($mod_CreateRightEdit_Callbackval->grouplinktable);

	$mod_groupvals = array(
		'user' => array('desc' => array($mod_txt['group_available'] . ':', sprintf($mod_txt['user_member_in'], $name) . ':'),
			'where' => '', 'select' => $esGroups, 'type' => 'user',
			'source' => intval($a), 'group_id' => "`$esGroups`.id"),

		'memberof' => array('desc' => array($mod_txt['group_available'] . ':', sprintf($mod_txt['group_member_in'], $name) . ':'),
			'where' => "WHERE `$esGroups`.id != " . intval($a), 'select' => $esGroups, 'type' => 'group',
			'source' => intval($a), 'group_id' => "`$esGroups`.id"),

		'usermember' => array('desc' => array($mod_txt['user_available'] . ':', sprintf($mod_txt['group_members_users'], $name) . ':'),
			'where' => '', 'select' => $esTable, 'type' => 'user',
			'source' => "`$esTable`.id", 'group_id' => intval($a)),

		'groupmember' => array('desc' => array($mod_txt['group_available'] . ':', sprintf($mod_txt['group_members_groups'], $name) . ':'),
			'where' => "WHERE `$esGroups`.id != " . intval($a), 'select' => $esGroups, 'type' => 'group',
			'source' => "`$esGroups`.id", 'group_id' => intval($a)),
	);

	$mod_groupvals = $mod_groupvals[$type];
	$name = ($type == 'usermember' ? 'username' : 'name');

	if ($mod_CreateRightEdit_Callbackval->savedelete)
	{
		if (stripos($mod_groupvals['where'], 'where') === false)
		{
			$mod_groupvals['where'] = 'WHERE ';
		}
		else
		{
			$mod_groupvals['where'] .= ' AND ';
		}
		$mod_groupvals['where'] .= "`$mod_groupvals[select]`.deleted = 0";
	}

	$query = "SELECT `$mod_groupvals[select]`.id, `$mod_groupvals[select]`.$name AS name, IFNULL(`$esLink`.id,0) AS link
			FROM `$mod_groupvals[select]`
			LEFT JOIN `$mod_CreateRightEdit_Callbackval->grouplinktable`
				ON `$mod_CreateRightEdit_Callbackval->grouplinktable`.type = '$mod_groupvals[type]'
				AND `$mod_CreateRightEdit_Callbackval->grouplinktable`.source = $mod_groupvals[source]
				AND `$mod_CreateRightEdit_Callbackval->grouplinktable`.group_id = $mod_groupvals[group_id]
			$mod_groupvals[where]
			ORDER BY $name";
	$result = mod_mysql_querya($query, $mod_CreateRightEdit_Callbackval->sql);
	$opt = array('', '');
	while ($tmp = mysql_fetch_assoc($result))
	{
		$opt[$tmp['link'] > 0 ? 1 : 0] .= "<option value=$tmp[id]>$tmp[name]</option>";
	}

	$list = new duallist;
	$list->data = $opt;
	$list->inputname = $inpname;
	$list->default = $a;
	$list->desc = $mod_groupvals['desc'];
	$list->fullids = true;
	$retVal = CreateFormDualList($list);
	unset($list);

	mysql_free_result($result);

	return($retVal);	
}

function mod_CreateGroupEdit_callback_user($a, $b, $name)
{
	return(mod_CreateGroupEdit_callback($a, $b, 'user', $name));
}
function mod_CreateGroupEdit_callback_memberof($a, $b, $name)
{
	return(mod_CreateGroupEdit_callback($a, $b, 'memberof', $name));
}
function mod_CreateGroupEdit_callback_usermember($a, $b, $name)
{
	return(mod_CreateGroupEdit_callback($a, $b, 'usermember', $name));
}
function mod_CreateGroupEdit_callback_groupmember($a, $b, $name)
{
	return(mod_CreateGroupEdit_callback($a, $b, 'groupmember', $name));
}

function CreateUserEdit_deletecallback($id)
{
	global $mod_CreateRightEdit_Callbackval, $modules_rights;

	foreach($mod_CreateRightEdit_Callbackval->protectadminuser as $right)
	{
		$esUser = mysql_escape_string($mod_CreateRightEdit_Callbackval->table);
		$query = "SELECT rights FROM `$esUser` WHERE id = $id";
		$userrights = intval(mysql_result(mod_mysql_querya($query, $mod_CreateRightEdit_Callbackval->sql), 0));

		if (($userrights & $modules_rights[$right]) == $modules_rights[$right])
		{
			$query = "SELECT COUNT(*) FROM `$esUser` WHERE (rights & $modules_rights[$right]) = $modules_rights[$right] AND id != $id";
			if ($mod_CreateRightEdit_Callbackval->savedelete) $query .= ' AND deleted = 0';
			if (mysql_result(mod_mysql_querya($query, $mod_CreateRightEdit_Callbackval->sql), 0) == 0)
			{
				return(-1);
			}
		}
	}

	if ($mod_CreateRightEdit_Callbackval->groups !== false)
	{
		$esLink = mysql_escape_string($mod_CreateRightEdit_Callbackval->grouplinktable);

		$query = "DELETE FROM `$esLink` WHERE type = 'user' AND source = $id";
		mod_mysql_querya($query, $mod_CreateRightEdit_Callbackval->sql);
	}
	if ($mod_CreateRightEdit_Callbackval->deletecallback !== false)
	{
		call_user_func($mod_CreateRightEdit_Callbackval->deletecallback, $id);
	}
}

function CreateUserCheckRightCallback($right)
{
	global $mod_CreateRightEdit_Callbackval, $userdata;

	$testright = ((isset($userdata) && $userdata['id']) ?
		(intval($mod_CreateRightEdit_Callbackval->protectuser) & (~ intval($userdata['rights']))) :
		$mod_CreateRightEdit_Callbackval->protectuser);

	if (intval($right) & intval($testright))
	{
		return(false);
	}
	return(true);
}

function mod_user_reg($id)
{
	global $mod_CreateRightEdit_Callbackval, $modules_defaults, $mod_txt;

	$esVal = mysql_escape_string($mod_CreateRightEdit_Callbackval->emailvalidate['table']);
	$esUser = mysql_escape_string($mod_CreateRightEdit_Callbackval->table);

	checkTable('validate', $mod_CreateRightEdit_Callbackval->emailvalidate['table'], $mod_CreateRightEdit_Callbackval->sql);

	$query = "SELECT * FROM `$esUser` WHERE id = " . intval($id);
	$tmp = mysql_fetch_assoc(mod_mysql_querya($query, $mod_CreateRightEdit_Callbackval->sql));
	$hash = md5(serialize($tmp) . time() . mt_rand(0, mt_getrandmax()));
	$time = time();

	$query = "INSERT INTO `$esVal` (user_id, hash, type, timestamp) VALUES ($id, '$hash', 0, $time)";
	mod_mysql_querya($query);

	$header = array();
	if (isset($mod_CreateRightEdit_Callbackval->emailvalidate['sender'])) $header[] = "From: " . $mod_CreateRightEdit_Callbackval->emailvalidate['sender'];
	else if (isset($modules_defaults['mail_from'])) $header[] = "From: $modules_defaults[mail_from]";

	$link = 'http://' . $mod_CreateRightEdit_Callbackval->emailvalidate['link'] . "&mod_java=" . (isset($_REQUEST['mod_java']) ? $_REQUEST['mod_java'] : 1) . "&mod_user_validate=$hash";

	mail($tmp['email'], isset($mod_CreateRightEdit_Callbackval->emailvalidate['caption']) ? $mod_CreateRightEdit_Callbackval->emailvalidate['caption'] : $mod_txt['user_valid_caption'], sprintf(isset($mod_CreateRightEdit_Callbackval->emailvalidate['text']) ? $mod_CreateRightEdit_Callbackval->emailvalidate['text'] : $mod_txt['user_valid_text'], ' ' . $link), implode("\r\n", $header));
}

function mod_user_validate($data, $reset = false)
{
	global $mod_txt, $mod_msg;
	$esVal = mysql_escape_string($reset ? $data->resetpw['table'] : $data->emailvalidate['table']);
	$esUser = mysql_escape_string($data->table);

	if ((!$reset && !isset($_REQUEST['mod_user_validate'])) || ($reset && !isset($_REQUEST['mod_user_reset_pw']))) return;

	$query = "SELECT * FROM `$esVal` WHERE timestamp < " . (time() - $data->validatetimeout);
	$result = mod_mysql_querya($query, $data->sql);
	while ($tmp = mysql_fetch_assoc($result))
	{
		if ($tmp['type'] == 0)
		{
			$query = "SELECT active FROM `$esUser` WHERE user_id = $tmp[user_id]";
			if (mysql_num_rows($result2 = mod_mysql_querya($query, $data->sql)) && mysql_result($result2, 0) != 1)
			{
				$query = "DELETE FROM `$esUser` WHERE user_id = $tmp[user_id]";
				mod_mysql_querya($query, $data->sql);
			}
		}
		mysql_free_result($result2);
		$query = "DELETE FROM `$esVal` WHERE id = $tmp[id]";
	}
	mysql_free_result($result);

	if ($reset)
	{
		$query = "SELECT `$esVal`.*, `$esUser`.password FROM `$esVal` LEFT JOIN `$esUser` ON `$esVal`.user_id = `$esUser`.id WHERE `$esVal`.type = 1 AND `$esVal`.hash = '" . mysql_escape_string($_REQUEST['mod_user_reset_pw']) . "'";
		if ($data->savedelete) $query .= " AND `$esUser`.deleted = 0";
		if ($data->activate || $data->emailvalidate !== false) $query .= ' AND active = 1';
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result))
		{
			$tmp = mysql_fetch_assoc($result);
			$newpw = strtolower(substr(md5($tmp['hash'] . $tmp['password']), 0, 8));

			$query = "UPDATE `$esUser` SET password = '" . md5($newpw) . "' WHERE id = $tmp[user_id]";
			mod_mysql_querya($query);

			$query = "DELETE FROM `$esVal` WHERE id = $tmp[id]";
			mod_mysql_querya($query);

			$mod_msg[] = $mod_txt['user_reset_pw'];
		}
		else
		{
			$mod_msg[] = $mod_txt['user_reset_error'];
		}
	}
	else
	{
		$query = "SELECT `$esVal`.* FROM `$esVal` LEFT JOIN `$esUser` ON `$esVal`.user_id = `$esUser`.id WHERE `$esVal`.type = 0 AND `$esUser`.active = 2 AND `$esVal`.hash = '" . mysql_escape_string($_REQUEST['mod_user_validate']) . "'";
		if ($data->savedelete) $query .= " AND `$esUser`.deleted = 0";
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result))
		{
			$tmp = mysql_fetch_assoc($result);
			$query = "UPDATE `$esUser` SET active = " . ($data->activate ? 0 : 1) . " WHERE id = $tmp[user_id]";
			mod_mysql_querya($query, $data->sql);
			$query = "DELETE FROM `$esVal` WHERE id = $tmp[id]";
			mod_mysql_querya($query, $data->sql);

			$mod_msg[] = $data->activate ? $mod_txt['user_activateda'] : $mod_txt['user_activated'];
		}
		else
		{
			$mod_msg[] = $mod_txt['user_activate_error'];
		}
	}
}

function mod_user_reset_pw($data)
{
	global $mod_txt, $modules_defaults, $mod_msg;
	mod_doDefaults($data);

	if (isset($_REQUEST['mod_user_reset_pw']))
	{
		mod_user_validate($data, true);
	}
	else if (isset($_REQUEST['mod_user_reset_pw_mail']) && isset($_REQUEST['mod_user_reset_pw_name']))
	{
		$esTable = mysql_escape_string($data->table);
		$query = "SELECT * FROM `$esTable` WHERE username = '" . mysql_escape_string($_REQUEST['mod_user_reset_pw_name']) . "' AND email = '" . mysql_escape_string($_REQUEST['mod_user_reset_pw_mail']) . "'";
		if ($data->savedelete) $query .= ' AND deleted = 0';
		if ($data->emailvalidate !== false || $data->activate) $query .= ' AND active = 1';
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result))
		{
			$tmp = mysql_fetch_assoc($result);
			checkTable('validate', $data->resetpw['table'], $data->sql);

			$hash = md5(serialize($tmp) . time() . mt_rand(0, mt_getrandmax()));
			$newpw = strtolower(substr(md5($hash . $tmp['password']), 0, 8));

			$esVal = mysql_escape_string($data->resetpw['table']);
			$time = time();

			$query = "INSERT INTO `$esVal` (user_id, hash, type, timestamp) VALUES ($tmp[id], '$hash', 1, $time)";
			mod_mysql_querya($query, $data->sql);

			$header = array();
			if (isset($data->resetpw['sender'])) $header[] = "From: " . $data->resetpw['sender'];
			else if (isset($modules_defaults['mail_from'])) $header[] = "From: $modules_defaults[mail_from]";

			$link = 'http://' . $data->resetpw['link2'] . (strpos($data->resetpw['link2'], '?') === false ? '?' : '') . $data->resetpw['link1'] . "&mod_java=" . (isset($_REQUEST['mod_java']) ? $_REQUEST['mod_java'] : 1) . "&mod_user_reset_pw=$hash";

			mail($tmp['email'], isset($data->resetpw['caption']) ? $data->resetpw['caption'] : $mod_txt['user_pw_caption'], sprintf(isset($data->resetpw['text']) ? $data->resetpw['text'] : $mod_txt['user_pw_text'], $link, $newpw), implode("\r\n", $header));
		}

		$mod_msg[] = $mod_txt['user_forgot_pw_sent'];
	}
	else
	{
		echo mod_linkToForm($data->defaultlink . $data->resetpw['link1']);
		echo "<table><tr><td>$mod_txt[user_username]</td><td><input name='mod_user_reset_pw_name' size=20></td></tr>
			<tr><td>E-Mail:</td><td><input name='mod_user_reset_pw_mail' size=20></td></tr></table><input type=submit value='$mod_txt[user_forgot_pw_send]'></form>";
	}
}

function mod_user_edit_notify($id)
{
	global $mod_msg, $mod_txt, $dwEditInstance;
	$mod_msg[] = $mod_txt['user_selfedited'];
}

function mod_user_registerlogin($id)
{
	global $mod_CreateRightEdit_Callbackval;

	$query = "UPDATE `" . mysql_escape_string($mod_CreateRightEdit_Callbackval->sessiontable) . "` SET user_id = $id";
	mod_mysql_querya($query, $mod_CreateRightEdit_Callbackval->sql);
	if ($mod_CreateRightEdit_Callbackval->tmp_createcallback !== false) call_user_func($mod_CreateRightEdit_Callbackval->tmp_createcallback, $id);
}

function CreateUserEdit($data, $register = false)
{
	global $mod_CreateRightEdit_Callbackval, $userdata, $mod_txt, $modules_rights;
	mod_doDefaults($data);

	if ($data->protectadminuser === true) $data->protectadminuser = $data->adminrights;

	if ($data->table === false)
	{
		trigger_error('No Table Name given!');
		return;
	}

	checkTable('user', $data->table, $data->sql);

	$edit = new sqledit;
	$edit->name = $mod_txt['user_user'];
	$edit->title = $mod_txt['user_title'];
	$edit->sql = $data->sql;
	$edit->sqltablename = $data->table;
	if ($data->relationtype === -1) $edit->relations = $data->relations;
	$edit->relations['username'] = array('name' => $mod_txt['user_username'], 'force' => true, 'nodual' => true);
	$edit->relations['password'] = array('name' => $mod_txt['user_password'], 'hide' => true, 'type' => 'md5', 'pw' => 2);
	$edit->defaultlink = $data->defaultlink;
	$edit->namefield = 'username';

	if ($data->changeonly && $userdata['id'] == 0) $data->register = false;

	if ($data->savedelete)
	{
		$edit->savedelete = true;
	}

	if ($data->protectuser !== false)
	{
		$data->protectuser = mod_collapseRightId($data->protectuser);
	}

	if ($data->addemail)
	{
		$edit->relations['email'] = array('name' => 'E-Mail');
		if ($data->addemail === true)
		{
			$edit->relations['email']['force'] = true;
		}
	}

	if ($register !== false)
	{
		if ($data->rights) $edit->adddefaults['rights'] = 0;
	}
	else if ($data->rights)
	{
		$edit->relations['rights'] = array('name' => $mod_txt['user_rights']);
		if ($data->rights !== true)
		{
			checkTable('rights', $data->rights, $data->sql);
			$edit->relations['rights']['type'] = 'callback';
			$edit->relations['rights']['func'] = 'CreateRightEdit_callback';
			if ($data->protectuser && (intval($data->protectuser) & intval($userdata['rights'])) != intval($data->protectuser))
			{
				$edit->relations['rights']['force'] = 'CreateUserCheckRightCallback';
				$esTable = mysql_escape_string($data->table);
				$edit->editable = "(`$esTable`.rights & $data->protectuser) = 0";
				$edit->deleteable = "(`$esTable`.rights & $data->protectuser) = 0";
				if (isset($userdata) && $userdata['id'])
				{
					$edit->editable .= " OR `$esTable`.id = $userdata[id]";
					$edit->deleteable .= " OR `$esTable`.id = $userdata[id]";
				}
			}
		}
	}

	$edit->deletecallback = 'CreateUserEdit_deletecallback';
	if ($register === false && $data->groups !== false)
	{
		checkTable('groups', $data->groups, $data->sql);
		checkTable('grouplink', $data->grouplinktable);
		$edit->relations['groups'] = array(	'name' => $mod_txt['user_groups'],
							'type' => 'callback',
							'func' => 'mod_CreateGroupEdit_callback_user',
							'sql' => '`' . mysql_escape_string($data->table) . '`.id',
							'hide' => true,
							'sqllink' => $data->grouplinktable,
							'sqllinkdata' => array('type' => 'user', 'group_id' => '[LINK]', 'source' => '[ID]'));
	}

	$edit->sortable = 'username ASC';
	if ($data->static)
	{
		$edit->addable = $edit->deleteable = false;
	}

	if ($register !== false)
	{
		$edit->editable = $edit->deleteable = false;
		$edit->showtable = false;
		if ($userdata['id'] && isset($_REQUEST['mod_editself']))
		{
			$edit->forceedit = $userdata['id'];
			$edit->defaultlink .= '&mod_editself=1';
			$edit->editable = true;
			$edit->editcallback = 'mod_user_edit_notify';
		}
		else
		{
			$edit->afterchange = $data->afterregister;
			if ($data->emailvalidate !== false) $edit->createcallback = 'mod_user_reg';
			if ($data->emailvalidate !== false) $edit->adddefaults['active'] = 2;
			else if ($data->activate) $edit->adddefaults['active'] = 0;
		}
	}

	if (!isset($_GET['mod_editself']) && $edit->editable && $data->activate)
	{
		if ($data->emailvalidate !== false)
		{
			$edit->relations['active'] = array('name' => 'Active', 'type' => 'select', 'options' => array(0 => 'No', 1 => 'Yes', 2 => 'Email Validation needed'));
		}
		else
		{
			$edit->relations['active'] = array('name' => 'Active', 'type' => 'checkbox');
		}
	}

	if ($data->relationtype !== -1) $edit->relations += $data->relations;
	$edit->adddefaults += $data->adddefaults;

	if ($data->limitadmin === true || $data->limitadmin === -1 || (is_string($data->limitadmin) && mod_user_defaultcallback($data->limitadmin) !== true))
	{
		$esUser = mysql_escape_string($data->table);
		foreach ($edit->relations as $index => $rel)
		{
			if (!in_array($index, $data->limitfields))
			{
				$edit->relations[$index]['editable'] = $data->limitadmin === -1 ? 'FALSE' : "`$esUser`.id = $userdata[id]";
			}
		}
	}

	$mod_CreateRightEdit_Callbackval = $data;
	$mod_CreateRightEdit_Callbackval->mod_edituser = 1;

	mod_doDefaults($edit, $data->editdata, true);

	if ($data->usercallback !== false)
	{
		$tmp = $data->usercallback;
		$tmp($edit);
	}

	if ($data->register && $data->registerlogin && $register && $userdata['id'] == 0 && $data->emailvalidate === false)
	{
		$mod_CreateRightEdit_Callbackval->tmp_createcallback = $edit->createcallback;
		$edit->createcallback = 'mod_user_registerlogin';
	}

	CreateSqlEdit($edit);

	unset($mod_CreateRightEdit_Callbackval->mod_edituser);
}

function CreateGroupEdit_deletecallback($id)
{
	global $mod_CreateRightEdit_Callbackval;
	$esLink = mysql_escape_string($mod_CreateRightEdit_Callbackval->grouplinktable);

	$query = "DELETE FROM `$esLink` WHERE group_id = $id OR (type = 'group' AND source = $id)";
	mod_mysql_querya($query, $mod_CreateRightEdit_Callbackval->sql);
}

function CreateGroupEdit($data)
{
	global $mod_CreateRightEdit_Callbackval, $mod_txt;
	mod_doDefaults($data);

	if (!($data->groups && $data->grouplinktable))
	{
		trigger_error('No Table Name given');
		return;
	}

	checkTable('user', $data->table, $data->sql);
	checkTable('groups', $data->groups, $data->sql);
	checkTable('grouplink', $data->grouplinktable, $data->sql);

	$edit = new sqledit;
	$edit->name = $mod_txt['group_group'];
	$edit->title = $mod_txt['group_title'];
	$edit->sql = $data->sql;
	$edit->sqltablename = $data->groups;
	if ($data->relationtype === -1) $edit->relations = $data->grouprelations;
	$edit->relations['name'] = array('name' => $mod_txt['user_group_name'], 'force' => true);

	if ($data->savedelete)
	{
		$edit->savedelete = true;
	}

	if (is_string($data->rights))
	{
		checkTable('rights', $data->rights, $data->sql);
		$edit->relations['rights'] = array('name' => $mod_txt['group_rights'], 'type' => 'callback', 'func' => 'CreateRightEdit_callback');
	}

	$edit->relations['usermembers'] = array('name' => $mod_txt['group_user_members'],
						'type' => 'callback',
						'func' => 'mod_CreateGroupEdit_callback_usermember',
						'sql' => '`' . mysql_escape_string($data->groups) . '`.id',
						'hide' => true,
						'sqllink' => $data->grouplinktable,
						'sqllinkdata' => array('type' => 'user', 'group_id' => '[ID]', 'source' => '[LINK]'));

	if ($data->groupingroup)
	{
		$edit->relations['memberof'] = array(	'name' => $mod_txt['group_member_of'],
							'type' => 'callback',
							'func' => 'mod_CreateGroupEdit_callback_memberof',
							'sql' => '`' . mysql_escape_string($data->groups) . '`.id',
							'hide' => true,
							'sqllink' => $data->grouplinktable,
							'sqllinkdata' => array('type' => 'group', 'group_id' => '[LINK]', 'source' => '[ID]'));
		$edit->relations['groupmembers'] = array('name' => $mod_txt['group_group_members'],
							'type' => 'callback',
							'func' => 'mod_CreateGroupEdit_callback_groupmember',
							'sql' => '`' . mysql_escape_string($data->groups) . '`.id',
							'hide' => true,
							'sqllink' => $data->grouplinktable,
							'sqllinkdata' => array('type' => 'group', 'group_id' => '[ID]', 'source' => '[LINK]'));
	}

	if ($data->protectuser !== false)
	{
		$data->protectuser = mod_collapseRightId($data->protectuser);
	}

	$mod_CreateRightEdit_Callbackval = $data;
	$edit->defaultlink = $data->defaultlink;
	$edit->deletecallback = 'CreateGroupEdit_deletecallback';

	if ($data->groupwhere)
	{
		$edit->sqlwhere = $data->groupwhere;
	}

	$edit->sortable = false;
	if ($data->static)
	{
		$edit->addable = $edit->deleteable = false;
	}

	if ($data->relationtype !== -1) $edit->relations += $data->grouprelations;
	$edit->adddefaults += $data->groupadddefaults;

	if ($data->groupcallback !== false)
	{
		$tmp = $data->groupcallback;
		$tmp($edit);
	}

	CreateSqlEdit($edit);
}

function mod_CreateUserLoginForm($defaultlink, $data = false, &$hash = false)
{
	global $mod_txt;
	$loginlink = $defaultlink;
	if ($data !== false)
	{
		$loginlink .= mod_addLink($data->adddefaultlink);
	}
	if ($data !== false && $data->ssllogin && $data->ssllogin !== true)
	{
		$data->ssllogin = $_SERVER['REMOTE_ADDR'] != '127.0.0.1';
	}
	if ($data !== false && $data->ssllogin)
	{
		$loginlink = "https://$_SERVER[HTTP_HOST]" . mod_link_prefile($loginlink);
	}
	else
	{
		$loginlink = mod_link_prefile($loginlink);
	}

	$retVal = mod_linkToForm($loginlink) . "<table>
		<tr><td>$mod_txt[login_username]:</td><td><input type='text' name='mod_username' " . ($data !== false ? "size='$data->loginWidth'" : '') . " value='User' onBlur='if(this.value==\"\")this.value=\"User\";' onFocus='this.value=\"\";'></td></tr>
		<tr><td>$mod_txt[login_password]:</td><td><input type='password' name='mod_password' value='password' " . ($data !== false ? "size='$data->loginWidth'" : '') . " onBlur='if(this.value==\"\")this.value=\"password\";' onFocus='this.value=\"\";'></td></tr>
		</table>";
	if ($data !== false && $hash !== false && $data->alwayssession)
	{
		$hash = isset($_REQUEST['mod_hash']) ? $_REQUEST['mod_hash'] : $hash;
		$retVal .= "<input type='hidden' name='mod_hash' value='$hash'>";
	}
	$retVal .= "<input type='submit' value='$mod_txt[login_login]'></form>";
	return($retVal);
}

function CreateUserLogin($data)
{
	global $userdata, $globaldata, $session, $modules_requirerights, $modules_rights, $mod_txt, $mod_msg, $modules_defaults, $mod_use;

	$errors = array();

	mod_doDefaults($data, 'modules_defaults', false, false);
	if (isset($_REQUEST['mod_java']) && strpos($data->defaultlink, 'mod_java') === false) $data->defaultlink .= '&mod_java=' . intval($_REQUEST['mod_java']);

	$esSession = mysql_escape_string($data->sessiontable);
	$esTable = mysql_escape_string($data->table);

	checkTable('user', $data->table, $data->sql);
	checkTable('session', $data->sessiontable, $data->sql);

	$query = "DESCRIBE `$esSession`";
	$fields = mod_Query2Array($query, $data->sql, 'Field');
	if (in_array('data', $fields)) $data->sessiondata = true;

	if ($data->globaldata !== false)
	{
		checkTable('globals', $data->globaldata, $data->sql);
		$query = "SELECT name, value FROM `" . mysql_escape_string($data->globaldata) . "` WHERE type = 'global'";
		$result = mod_mysql_querya($query, $data->sql);
		$globaldata = array();
		while ($tmp = mysql_fetch_assoc($result))
		{
			$globaldata[$tmp['name']] = $tmp['value'];
		}
	}

	if (is_string($data->rights))
	{
		checkTable('rights', $data->rights, $data->sql);
		$esRights = mysql_escape_string($data->rights);
		$query = "SELECT right_id, name FROM `$esRights`";
		$result = mod_mysql_querya($query, $data->sql);
		while ($tmp = mysql_fetch_assoc($result))
		{
			$modules_rights[strtolower($tmp['name'])] = intval($tmp['right_id']);
		}
		mysql_free_result($result);
	}

	if ($data->counter && !isset($globaldata['counter'])) $globaldata['counter'] = 0; else $globaldata['counter'] = intval($globaldata['counter']);

	$query = "DELETE FROM `$esSession` WHERE timestamp < " . (time() - $data->timeout);
	mod_mysql_querya($query, $data->sql);

	if (isset($_REQUEST['mod_hash']))
	{
		$query = "SELECT * FROM `$esSession` WHERE md5 = '" . mysql_escape_string($_REQUEST['mod_hash']) . "' AND ip = " . sprintf('%u', ip2long($_SERVER['REMOTE_ADDR']));
		$result = mod_mysql_querya($query, $data->sql);

		if (mysql_num_rows($result))
		{
			$sessiondata = mysql_fetch_assoc($result);

			$query = "UPDATE `$esSession` SET timestamp = " . time() . " WHERE id = $sessiondata[id]";
			mysql_query($query, $data->sql);

			if ($data->alwayssession && $sessiondata['user_id'] == 0)
			{
				$userdata = array('id' => 0, 'rights' => 0);
				$data->addlink = "&mod_hash=$_REQUEST[mod_hash]";
				if (strpos($data->defaultlink, 'mod_hash') === false) $data->defaultlink .= $data->addlink;
			}
			else
			{
				$query = "SELECT * FROM `$esTable` WHERE id = $sessiondata[user_id]";
				if ($data->savedelete)
				{
					$query .= ' AND deleted = 0';
				}
				if ($data->activate || $data->emailvalidate !== false)
				{
					$query .= ' AND active = 1';
				}

				$result2 = mod_mysql_querya($query, $data->sql);
				if (($tmpnum = mysql_num_rows($result2)) && !isset($_REQUEST['logout']))
				{
					$userdata = mysql_fetch_assoc($result2);

					if ($data->alias !== false && mod_user_defaultcallback($data->alias) === true)
					{
						if (isset($_REQUEST['mod_alias']))
						{
							$sessiondata['alias'] = intval($_REQUEST['mod_alias']);
							$query = "UPDATE `$esSession` SET alias = $sessiondata[alias] WHERE id = $sessiondata[id]";
							mod_mysql_querya($query, $data->sql);
						}
						
						if ($sessiondata['alias'])
						{
							if (mod_checkTableID($data->table, $sessiondata['alias'], $data->sql))
							{
								$query = "SELECT * FROM `$esTable` WHERE id = $sessiondata[alias]";
								$userdata = array_merge(mysql_fetch_assoc(mod_mysql_querya($query, $data->sql)), array('user_noalias' => $userdata['id'], 'alias_rights' => $userdata['rights']));
							}
						}
					}

					$data->addlink = "&mod_hash=$_REQUEST[mod_hash]";
					if (strpos($data->defaultlink, 'mod_hash') === false) $data->defaultlink .= $data->addlink;
				}
				else
				{
					if (isset($_REQUEST['logout']) && $tmpnum && $data->alwayssession)
					{
						$userdata = array('id' => 0, 'rights' => 0);
						$data->addlink = "&mod_hash=$_REQUEST[mod_hash]";
						if (strpos($data->defaultlink, 'mod_hash') === false) $data->defaultlink .= $data->addlink;
						$query = "UPDATE `$esSession` SET user_id = 0 WHERE id = $sessiondata[id]";
					}
					else
					{
						$query = "DELETE FROM `$esSession` WHERE id = $sessiondata[id]";
					}
					mod_mysql_querya($query, $data->sql);
				}
				mysql_free_result($result2);
			}
		}
		mysql_free_result($result);
	}

	if ($data->action === false && isset($modules_defaults['action_table']) && isset($modules_defaults['action_defaults']) && isset($modules_defaults['action_defaults'][$data->table . '_login']))
	{
		$data->action = array();
	}

	if (isset($_POST['mod_username']) && $data->action !== false)
	{
		if (!isset($data->action['type'])) $data->action['type'] = $data->table . '_login';
		if ($resttime = mod_checkAction($data->action, $_POST['mod_username'], false, $data->sql, false) !== true)
		{
			if (isset($data->action['msg'])) $errors[] = $data->action['msg'];
			else $errors[] = sprintf($mod_txt['user_action_wait'], -$resttime);
			unset($_POST['mod_username']);
		}
	}

	if (isset($_POST['mod_username']))
	{
		$query = "SELECT * FROM `$esTable` WHERE username = '" . mysql_escape_string($_POST['mod_username']) . '\'';
		if ($data->savedelete) $query .= " AND `$esTable`.deleted = 0";
		$result = mod_mysql_querya($query, $data->sql);

		if (mysql_num_rows($result))
		{
			$tmp = mysql_fetch_assoc($result);
			if ($tmp['password'] != md5($_POST['mod_password']))
			{
				$mod_msg[] = $mod_txt['user_invalid_password'];
				if ($data->resetpw)
				{
					$mod_msg[] = "<i>(<a href='$data->defaultlink" . $data->resetpw['link1'] . "'>$mod_txt[user_forgot_pw]</a>)</i>";
				}
				unset($tmp);
			}
			else if (($data->activate || $data->emailvalidate !== false) && $tmp['active'] != 1)
			{
				$mod_msg[] = $mod_txt['user_not_activated'];
				unset($tmp);
			}
			else if ($data->savedelete && $tmp['deleted'] != 0)
			{
				unset($tmp);
			}
		}

		if (isset($tmp) && mysql_num_rows($result))
		{
			$userdata = $tmp;
			if ($data->alwayssession && isset($sessiondata))
			{
				$query = "UPDATE `$esSession` SET user_id = $userdata[id] WHERE id = $sessiondata[id]";
			}
			else
			{
				$hash = md5(time() . serialize($userdata) . $_SERVER['REMOTE_ADDR'] . mt_rand(0, 16384) . serialize($_SERVER));
				$data->addlink .= "&mod_hash=$hash";
				$data->defaultlink .= "&mod_hash=$hash";
				$query = "INSERT INTO `$esSession` (user_id, md5, ip, timestamp" . ($data->sessiondata ? ', data' : '') . ") VALUES ($userdata[id], '" . $hash . "', " . sprintf('%u', ip2long($_SERVER['REMOTE_ADDR'])) . ', ' . time() . ($data->sessiondata ? (',"' . mysql_escape_string(serialize(array())) . '"') : '') . ')';
				if ($data->counter) $globaldata['counter']++;
			}
			
			mod_mysql_querya($query, $data->sql);
			if (!isset($sessiondata)) $sessiondata = array('id' => mysql_insert_id($data->sql));
			if ($data->alias)
			{
				$query = "UPDATE `$esSession` SET alias = 0 WHERE id = $sessiondata[id]";
				mod_mysql_querya($query, $data->sql);
			}
		}
		else
		{
			$errors[] = $mod_txt['user_denied'];
			if ($data->action !== false)
				mod_checkAction($data->action, $_POST['mod_username'], false, $data->sql);
		}
		mysql_free_result($result);
	}
	else if (!isset($userdata) && $data->alwayssession)
	{
		$hash = md5(time() . rand(0, 16384) . mt_rand(0, 16384) . mt_rand(0, 16384) . mt_rand(0, 16384) . serialize($_SERVER));
		$query = "INSERT INTO `$esSession` (user_id, md5, ip, timestamp" . ($data->sessiondata ? ', data' : '') . ") VALUES (0, '$hash', " . sprintf('%u', ip2long($_SERVER['REMOTE_ADDR'])) . ", " . time() . ($data->sessiondata ? (',"' . mysql_escape_string(serialize(array())) . '"') : '') . ")";
		mod_mysql_querya($query, $data->sql);

		$userdata = array('id' => 0, 'rights' => 0);
		$sessiondata = array('id' => mysql_insert_id($data->sql));
		$data->addlink .= "&mod_hash=$hash";
		$data->defaultlink .= "&mod_hash=$hash";

		if ($data->counter) $globaldata['counter']++;
	}

	if ($modules_requirerights && !mod_user_defaultcallback($modules_requirerights))
	{
		if ($data->permissiondenied === false)
		{
			die("Permission Denied");
		}
		else
		{
			call_user_func($data->permissiondenied);
		}
	}

	if ($data->userdata && isset($userdata) && $userdata['id'])
	{
		if (!is_array($userdata['data'] = unserialize($userdata['data']))) $userdata['data'] = array();
		if (is_string($data->userdata))
		{
			$userdata['data'] = array_merge($userdata['data'], mod_retrieveArrayFromTable($data->sql, $data->userdata, array('ref' => $userdata['id'], 'type' => 'user')));
			if (isset($modules_defaults['user_data_config'])) $userdata['data']['mod_config'] = mod_retrieveArrayFromTable($data->sql, $data->userdata, array('ref' => $userdata['id'], 'type' => 'userconf'));
		}
		if (isset($modules_defaults['user_data_config']))
		{
			if (!isset($userdata['data']['mod_config'])) $userdata['data']['mod_config'] = array();

			if (isset($userdata['data']['mod_config']['language']))
			{
				mod_SetLanguage($mod_use->language = $modules_defaults['language'] = $userdata['data']['mod_config']['language'], true);
				if (!isset($mod_use)) mod_ExportJavaLanguage(true);
			}
		}
	}

	if ($data->groups)
	{
		checkTable('groups', $data->groups, $data->sql);
		checkTable('grouplink', $data->grouplinktable, $data->sql);
		$esGroupTable = mysql_escape_string($data->groups);
		$esGroupLinkTable = mysql_escape_string($data->grouplinktable);
		$userdata['groups'] = array();
	}

	if (!isset($userdata) || $userdata['id'] == 0)
	{
		$userdata = array('id' => 0, 'rights' => 0);

		$retVal = mod_CreateUserLoginForm($data->defaultlink, $data, $hash);

		if (count($errors))
		{
			$retVal .= '<font style="color:red;font-weight:bold;">' . implode('<br>', $errors) . '</font><br>';
		}

		if ($data->register !== false && !$data->changeonly)
		{
			$retVal .= "<a href='$data->defaultlink$data->register'>$mod_txt[user_reg]</a>";
		}
	}
	else
	{
		$retVal = sprintf($mod_txt['login_logged_in'], $userdata['username']) . "<br><a href='$data->defaultlink" . ($data->alwayssession && isset($_REQUEST['mod_hash']) ? "&mod_hash=$_REQUEST[mod_hash]" : '') . mod_addLink($data->adddefaultlink) . "&logout=1'>$mod_txt[login_logout]</a>";

		if ($data->groups)
		{
			$userdata['groups'][] = 0;
			$query = "SELECT group_id FROM `$esGroupLinkTable` WHERE type = 'user' AND source = $userdata[id]";
			do
			{
				$newgroups = mod_Query2Array($query, $data->sql, 0);
				$query = "SELECT group_id FROM `$esGroupLinkTable` WHERE type = 'group' AND source IN (" . implode(',', $userdata['groups']) . ") AND group_id NOT IN (" . implode(',', $userdata['groups']) . ")";
				$userdata['groups'] = array_merge($userdata['groups'], $newgroups);
			} while (count($newgroups));
		}
		if ($data->register !== false)
		{
			$retVal .= "<br><a href='$data->defaultlink$data->register&mod_editself=1'>$mod_txt[user_selfedit]</a>";
		}

		if ($data->alias !== false && ((mod_user_defaultcallback($data->alias)) || (isset($userdata['alias_rights']) && (intval($modules_rights[$data->alias]) & intval($userdata['alias_rights'])) === intval($modules_rights[$data->alias]))))
		{
			$retVal .= '<hr>' . mod_linkToForm($_SERVER['PHP_SELF'] . $data->defaultlink) . "<select name='mod_alias'>" . mod_createselectoptions("SELECT id, " . ($data->savedelete ? 'CONCAT(IF(deleted=0,"","(!) "), username), IF(deleted=0,0,1) AS del' : 'username') . " FROM `$esTable` ORDER BY " . ($data->savedelete ? 'del ASC, ' : '') . 'username ASC', $data->sql, isset($sessiondata['alias']) ? $sessiondata['alias'] : 0, false) .
				'</select><br><input type=submit value="' . $mod_txt['user_alias'] . '"> <input type="button" value="' . $mod_txt['user_alias_re'] . '" onClick="document.location.href=\'' . AddSlashes($data->defaultlink) . '&mod_alias=0\';"></form>';
		}
	}

	if (isset($sessiondata) && $sessiondata['id'] != 0) $userdata['session_id'] = $sessiondata['id'];

	if ($data->sessiondata && isset($userdata['session_id']) && $userdata['session_id'])
	{
		$query = "SELECT data FROM `$esSession` WHERE id = $userdata[session_id]";
		$session = mysql_result(mod_mysql_querya($query, $data->sql), 0);
		$session = $session == '' ? array() : unserialize($session);
	}

	$userdata['rights'] = intval($userdata['rights']);
	if (isset($userdata['groups']) && is_string($data->rights))
	{
		foreach($userdata['groups'] as $group)
		{
			$query = "SELECT rights FROM `$esGroupTable` WHERE id IN (" . implode($userdata['groups']) . ')';
			$result = mod_mysql_querya($query, $data->sql);
			while ($tmp = mysql_fetch_assoc($result))
			{
				$userdata['rights'] |= intval($tmp['rights']);
			}
		}
	}

	if ($userdata['rights'])
	{
		foreach($data->adminrights as $adminright)
		{
			if (isset($modules_rights[$adminright]) && (intval($modules_rights[$adminright]) & $userdata['rights']) == intval($modules_rights[$adminright]))
			{
				foreach ($modules_rights as $right => $right_id)
				{
					if (!in_array($right, $data->protectadminrights))
					{
						$userdata['rights'] |= intval($right_id);
					}
				}
				break;
			}
		}
	}

	if ($data->groups && $data->commongroup !== false)
	{
		$query = "SELECT id FROM `$esGroupTable` WHERE name = '" . mysql_escape_string($data->commongroup) . "'";
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result))
		{
			$userdata['groups'][] = mysql_result($result, 0);
		}
		else
		{
			trigger_error('Common Group does not exist', E_USER_ERROR);
		}
	}

	return($retVal);
}

function SaveSession($data)
{
	global $userdata, $globaldata, $session, $modules_defaults;
	if ($data->sessiondata !== true) trigger_error('Invalid User Class', E_USER_ERROR);
	if (!isset($userdata['session_id']) || !$userdata['session_id']) trigger_error('Cannot find session id', E_USER_ERROR);
	$query = "UPDATE `" . mysql_escape_string($data->sessiontable) . "` SET data = '" . mysql_escape_string(serialize($session)) . "' WHERE id = $userdata[session_id]";
	mod_mysql_querya($query, $data->sql);

	if ($data->userdata)
	{
		if ($userdata['id'] != 0)
		{
			if (is_string($data->userdata))
			{
				$query = "DELETE FROM `" . mysql_escape_string($data->userdata) . "` WHERE ref = $userdata[id] AND (type = 'user' OR type = 'userconf')";
				mod_mysql_querya($query);
				if (isset($modules_defaults['user_data_config']) && $modules_defaults['user_data_config'])
				{
					$tmpconf = $userdata['data']['mod_config'];
					unset($userdata['data']['mod_config']);
				}
				mod_storeArrayInTable($data->sql, $data->userdata, $userdata['data'], array('ref' => $userdata['id'], 'type' => 'user'));
				if (isset($tmpconf))
				{
					mod_storeArrayInTable($data->sql, $data->userdata, $tmpconf, array('ref' => $userdata['id'], 'type' => 'userconf'));
					$userdata['data']['mod_config'] = $tmpconf;
				}
			}
			$query = "UPDATE `" . mysql_escape_string($data->table) . "` SET data = '" . mysql_escape_string(serialize(is_string($data->userdata) ? array() : $userdata['data'])) . "'";
			mod_mysql_querya($query, $data->sql);
		}
	}

	if ($data->globaldata !== false)
	{
		$query = "DELETE FROM `" . mysql_escape_string($data->globaldata) . "` WHERE type = 'global'";
		mod_mysql_querya($query, $data->sql);
		foreach ($globaldata as $index => $value)
		{
			$query = "INSERT INTO `" . mysql_escape_string($data->globaldata) . "` (name, value, type) VALUES ('" .
				mysql_escape_string($index) . "', '" . mysql_escape_string($value) . "', 'global')";
			mod_mysql_querya($query, $data->sql);
		}
	}
}

function mod_user_defaultcallback($misc)
{
	global $userdata, $modules_rights;

	if (is_array($misc))
	{
		foreach ($misc as $chk)
		{
			if (mod_user_defaultcallback($chk) == false)
			{
				return(false);
			}
		}
		return(true);
	}

	if (!is_numeric($misc))
	{
		if (!isset($modules_rights[strtolower($misc)])) return(false);
		$misc = $modules_rights[strtolower($misc)];
	}
	if ($misc == -100)
	{
		return($userdata['id'] != 0);
	}

	return((intval($userdata['rights']) & intval($misc)) == intval($misc));
}

function ShowSessions($data, $info = true, $terminate = false)
{
	checkTable('user', $data->table, $data->sql);
	checkTable('session', $data->sessiontable, $data->sql);

	mod_doDefaults($data);

	$esUser = mysql_escape_string($data->table);
	$esSession = mysql_escape_string($data->sessiontable);
	$time = time();

	if ($info)
	{
		$infoquery = ', INET_NTOA(ip) AS IP';
	}
	else $infoquery = '';

	if ($terminate === true)
	{
		$termpart = ", CONCAT('<a href=\"" . mysql_escape_string($data->defaultlink) . "&mod_termsession=', `$esSession`.id, '\">Terminate</a>') AS Terminate";
		if (isset($_REQUEST['mod_termsession']))
		{
			$query = "DELETE FROM `$esSession` WHERE id = " . intval($_REQUEST['mod_termsession']);
			mod_mysql_querya($query, $data->sql);
		}
		$termpart2 = '';
	}
	else
	{
		$termpart =  '';
		$termpart2 = "WHERE `$esUser`.id IS NOT NULL";
	}

	$query = "SELECT
			IFNULL(`$esUser`.username, '-') AS User,
			CONCAT(($time - `$esSession`.timestamp), ' Seconds') AS Idle,
			CONCAT(($data->timeout - $time + `$esSession`.timestamp), ' Seconds') AS Timeout
			$termpart
		$infoquery
		FROM `$esSession` LEFT JOIN `$esUser` ON user_id = `$esUser`.id $termpart2 ORDER BY timestamp DESC";
	CreateTableA(array('data' => $query, 'title' => 'Sessions', 'width' => '90%'));
}

function CreateUserRegister($data)
{
	global $userdata;
	if ($data->changeonly && (!isset($_REQUEST['mod_editself']) || $userdata['id'] == 0)) return;
	CreateUserEdit($data, true);
}

function mod_collapseRightId($rights)
{
	global $modules_rights;
	$retVal = 0;
	if (!is_array($rights)) $rights = array($rights);
	foreach ($rights as $right)
	{
		$retVal |= intval(is_numeric($right) ? $right : $modules_rights[$right]);
	}
	return($retVal);
}

function CreateUserConfig($use = true, $user = false, $add = false)
{
	global $userdata;

	$configarray = array(
		'language' => array('html' => 'Sprache', 'default' => 'de', 'data' => array('de' => 'Deutsch', 'en' => 'English'), 'name' => 'lang'),
		'template' => array('html' => 'Template', 'default' => 'simple', 'data' => array('simple' => 'Simple', 'standard' => 'Standard', 'classic' => 'Classic'), 'name' => 'mod_template'),
		'font' => array('html' => 'Schriftart', 'default' => 'Times New Roman', 'type' => 'text'),
		'forum_sort' => array('html' => 'Forum sortierung', 'default' => 1, 'data' => array(0 => 'Interne sortierung', 1 => 'Neueste zuerst', 2 => 'lteste zuerst')),
		'forum_display' => array('html' => 'Forum Ansicht', 'default' => 0, 'data' => array(0 => 'High Res', 1 => 'Low Res')),
		'java_menu' => array('html' => 'Java Menu', 'default' => '', 'type' => 'checkbox'),
		'java_tables' => array('html' => 'Java Tables', 'default' => 'checked', 'type' => 'checkbox')
	);

	$usearray = array();
	foreach ($configarray as $index => $param)
	{
		if (($use === true || in_array($index, $use)) && ($userdata['id'] || isset($param['name'])))
		{
			$usearray[$index] = $param;
		}
	}
	if (is_array($add)) $usearray += $add;
	
	if (count($valnames = mod_param_configarray($userdata['data']['mod_config'], $usearray)) && $userdata['id'] && $user !== false && !isset($_REQUEST['mod_conf_upd']))
	{
		$_REQUEST['mod_conf_upd'] = 1;
		SaveSession($user);
		mod_redir_changes($valnames);
	}
}

?>